﻿Version=6.75
NumberOfForms=0
NumberOfObjects=3
Object1=con:Connection
Object2=cmd:Command
Object3=reader:DataReader
Sub designer
end sub
@EndOfDesignText@
Sub Globals
	'Declare the global variables here.
	Public Job,ZCK,DS(20),dsp(80)
	Public CD,CB,Y,X,Z,Y2,X2,Z2,ATF,SCF,HC,HS,VC,PCN,DZ,DZ1,ST,D1
	Public j,jj,SV,SV1,EIN(1000),EIN1(50),OF,Tfc,Sdv,Zp,Ori,Afp

	Public lclevel,llevel,rlevel,blevel,tlevel,lwidth,rwidth,lcrossfall,rcrossfall,ledgeh,ledgew,redgeh,redgew 
	Public lshw,lshcross,rshw,rshcross,StakeOffset,GradeOffset,GradeShift
	Public SBPOffset,SBPLevel,ToeOffset,ToeLevel,SlopeAngle,SlopeLength,NoBat,Pos

	Dim Eod,Srt,Skip,FreePos,Tsw,mo,my,mx,mz,dy,dx,Yco,Xco,Ycn,Xcn,mf,mr,OG,AG,Yc,Xc,Zc,lt,d2,NP,zal,zall
	Dim Maxpt,Minpt
	
	Dim F1(20),IRIM(20),P
	
End Sub

#Region ****************************************************** Maths

Public Sub CK008(A,Code)
	'1 = converts to degrees
	'2 = converts to degrees minutes & seconds
	Dim D0,D2,D3,S
	
	If Code=1 Then
	   ' *DEG*
		If A=0 OR A=1E20 Then
			ZCK=A
			Return ZCK
		End If
		If Main.DF(10)=1 Then          
		   ' grades
			ZCK=A*9/10 
			Return ZCK
		End If
		ZCK=A :S=ZCK/(Abs(ZCK)+1E-13) :ZCK=ZCK+1E-13 :ZCK=Abs(ZCK)
		D0=Int(ZCK) :D2=(ZCK-D0)*100 :D3=(D2-Int(D2))*100 :D2=Int(D2)
		ZCK=(D0+D2/60+D3/3600)*S 
		Return ZCK
	Else If Code=2 Then      
	   ' *DMS*
		If A=0 OR A=1E20 Then 
			ZCK=A
			Return ZCK
		End If
		If Main.DF(10)=1 Then
			ZCK=A*10/9 
			Return ZCK  
		End If
		ZCK=A 
		If ZCK>=360 Then ZCK=ZCK-360 
		If ZCK<0 Then ZCK=ZCK+360 
		S=ZCK/(Abs(ZCK+1E-13)) :ZCK=Abs(ZCK)
		D0=Int(ZCK) :D2=(ZCK-D0)*60 :D3=(D2-Int(D2))*60 :D2=Int(D2)
		If D3>=59.5 Then	
			D3=0 :D2=D2+1
			If D2>=60 Then
				D0=D0+1 :D2=D2-60 
			End If
		End If
		ZCK=(D0+D2/100+D3/10000)*S 
		Return ZCK 
	Else If Code=3 Then 
		A=ACos(A)
		ZCK=(Main.DEG*A)
	Else If Code=4 Then 
		A=ASin(A)
		ZCK=(Main.Deg*A)
	Else If Code=5 Then
		ZCK=A-Int(A/360)*360
		If ZCK=360 Then 
			ZCK=0 
		End If
		Return 
	Else If Code=6 Then
	   	ZCK=A
		If Abs(A)>180*3600 Then
			ZCK=A-(A/(Abs(A)))*360*3600 
		End If
		Return
	End If
End Sub

Public Sub CK006(Y1,X1,B1,D3,Code)
	Dim R1
	
	If Code=1 Then      
	   ' *Join*
		dy=(B1-Y1)
		dx=(D3-X1) 
		CD=Sqrt(dx*dx+dy*dy)
		If dx=0 AND dy=0 Then
			CD=0 :CB=0 
		End If
		If dx=0 AND dy<>0 Then
		   If dy=0 Then dy=0.000000001
			CB=Main.PI/2*(dy/Abs(dy))
		Else
		   If dx=0 Then dx=0.000000001
			CB=ATan(dy/dx) 
		End If   
		If dx<0 Then CB=CB+Main.PI 
		If CB<0 Then CB=CB+2*Main.PI 
		CB=(180/Main.PI)*(CB) :CB=CB+2E-10
	Else If Code=2 Then     
	   ' *POLAR*
		R1=(Main.PI/180)*(B1) 
		Y2=Y1+Sin(R1)*D3 
		X2=X1+Cos(R1)*D3 
	End If
End Sub

Public Sub CK012(Z1,V1,D3,I1,P1,Flg,Code2)
	Dim BV,RV,EO,D0,Vag,RFRC,MB,MV

	If Main.ATF=0  Then Main.ATF=1.0 
	If Main.SCF=0 Then Main.SCF=1.0 
	If Code2=1 Then 
		' *RSLD*
 		RV=Main.RAD*(V1) :BV=Abs(Sin(RV))
		HS=D3*Main.ATF*Main.SCF+Main.pcn
		HS=HS*BV
		Return HS
	Else If Code2=2 Then
		' *TRGH*
		If Flg<>0 Then
			Engine.CK012(0.0,V1,D3,0.0,0.0,0,1)
			HS=HS/(Main.SCF+0.000000001) 
		Else 
			HS=D3/Main.SCF 
		End If
		If HS=0 OR V1=0 Then
			DZ=0.0 :Z2=0.0 
			Return
		End If
		RFRC=.87*(HS/Main.ERD)*(HS/2) :DZ=0 :MV=V1+VC
		If MV>0 AND MV<180 Then Vag=Main.RAD*(90-MV) 
		If MV>180 AND MV<360 Then Vag=Main.RAD*(MV-270)
		DZ=HS*Tan(Vag)+RFRC+I1-P1 :Z2=Z1+DZ
		DZ1=(0-(HS*Tan(Vag)+RFRC))-I1+P1
	End If
End Sub

Public Sub CalcPolar(Y9,X9,Z9,A,A1,A2)
	Dim H1,V1,V2,HD
	
	If A<>"" AND A1<>"" AND A2<>"" Then
		CK008(A,1)
		H1=ZCK
		CK008(A1,1)
		V1=ZCK
		If V1>180 Then V1=V1-180 
		V2=Sin(Main.RAD*(V1)) 
		HD=A2*V2 
		CK006(Y9,X9,H1,HD,2)
		Z2=Z9+((Cos(Main.RAD*(V1)))*A2)	
	Else
		Y2=0 :X2=0 :Z2=0
		Msgbox ("Not Enough Information Has Been Entered", "Missing Info", cMsgboxOK, cMsgboxExclamation)
		Return
	End If
End Sub

Public Sub CK096(YY1,XX1,B1,YY2,XX2,B2,YY3,XX3,B3,Code)
	Dim BL,BR,BR1,BR2,TN1,TN2,ya,xa,yb,xb,yc,xc,yp1,xp1,yp2,xp2,all,bll
	
	Y=1e20 :X=1e20
	If Code=2 OR Code=5 Then
		ya=YY1 :xa=XX1 :yb=YY2 :xb=XX2
		BL=Abs(B1) :BR=Abs(B2) :BR1=Main.RAD*B1 :BR2=Main.RAD*B2
		If BL=90 OR BL=270 OR BR=90 OR BR=270 Then
			If BR=90 OR BR=270 Then
		    	TN1=Tan(BR1) :TN2=Tan(BR2-(1E-4)) :Y=(ya+(xb-xa)*TN1-yb*TN1/TN2)/(1-TN1/TN2)
				X=xb+(Y-yb)/TN2
			End If
			If BL=90 OR BL=270 Then
				TN1=Tan(BR2) :TN2=Tan(BR1-(1E-4)) :Y=(yb+(xa-xb)*TN1-ya*TN1/TN2)/(1-TN1/TN2)
				X=xa+(Y-ya)/TN2
			End If
		Else
			TN1=Tan(BR1) :TN2=Tan(BR2) :X=(yb-ya+xa*TN1-xb*TN2)/(TN1-TN2) :Y=ya+(X-xa)*TN1
		End If
		DS(1)=Y :DS(2)=X
	Else If Code=3 OR Code=6 Then
		ya=YY1 :xa=XX1 :yb=YY2 :xb=XX2
		Engine.CK006(ya,xa,yb,xb,1)
		all=(B1*B1+CD*CD-B2*B2)/(2*B1*CD) 
		Engine.CK008(all,3)
		all=ZCK
		If all<0 Then all=all+180 
		bll=CB+all 
		Engine.CK006(ya,xa,bll,B1,2)
		Y=Y2 :X=X2
		DS(1)=Y :DS(2)=X
	Else If Code=4 Then
		ya=YY1 :xa=XX1 :yb=YY2 :xb=XX2 :yc=YY3 :xc=XX3
		all=B2-B1 :bll=B3-B2 
		Engine.CK008(all,5) :all=ZCK 
		Engine.CK008(bll,5) :bll=ZCK
		If all=90 OR all=270 Then all=all+(1E-8) 
		If bll=90 OR bll=270 Then bll=bll+(1E-8)
		'all=Tan(Radius*all) :bll=Tan(Radius*bll)
		If all=0 OR bll=0 Then
			Y=1E20 :X=1E20 
			Return
		End If
		yp1=ya-(xa-xb)/all :xp1=xa+(ya-yb)/all
		yp2=yc+(xc-xb)/bll :xp2=xc-(yc-yb)/bll
		Engine.CK006(yp1,xp1,yp2,xp2,1) 
		BL=CB :BR=CB+90 
		Engine.CK008(BR,5) :BR=ZCK
		If CD=0 Then
			'at 2,8 :Print "Dangerous Circle" :Y=1E20 :X=Y :RETURN 
		End If
		Engine.CK096(yp1,xp1,BL,YY2,XX2,BR,0.0,0.0,0.0,2)
	End If
	'RETURN
	'NOSOL:: :Y=1E20 :X=1E20 :ONERR OFF :RETURN         
	
End Sub

Public Sub CK102(A,B,Code)
	Dim S,ya,xa,yb,xb,R,L,COD,Bog,fh
	
	If Code= 1 Then
	 	' *Mod*
		' A=FLT(A) :B=FLT(B) 
		If B=0 Then
			SV1=-999999
			Return
		End If
		'S=(A/B)/(Abs(A/B)) :C1=(Int((A/B-Int(A/B))*B+.05))*S :Return(Int(C1))
	Else If Code=2 Then
		' *ELCLSV*
		jj=A-B+1 :j=A+1 
		SV1=Data.EIN(jj) :ya=Data.EIN(jj+1) :xa=Data.EIN(jj+2)
		yb=Data.EIN(j+1) :xb=Data.EIN(j+2) :R=Data.EIN(j+3) :L=Data.EIN(j+4) :COD=Data.EIN(j+5)
		If L=0.000 Then
			COD=0 :EIN(j+5)=COD  
		End If
		Engine.CK006(ya,xa,yb,xb,1)
		If Int(R*1000)=0 AND Int(L*1000)=0 Then
			SV1=SV1+CD 
			Return
		End If
		If Int(L*1000)<>0 Then
			If Int(R*1000)=0 Then
				Msgbox ("Transition R=0 ?","Data Corrupt",cMsgboxOK,cMsgboxExclamation)
				j=-999999
				Return
		 	End If
			If L<Engine.CD Then
				Msgbox ("Length Too Small","Data Corrupt",cMsgboxOK,cMsgboxExclamation)
				j=-999999
				Return
			End If
			If COD<>1 AND COD<>2 Then
				Msgbox ("T/Code = 1 Or 2","Data Corrupt",cMsgboxOK,cMsgboxExclamation)
				j=-999999
				Return
			End If
			SV1=SV1+L
		End If
	'	If R<>0.000 Then
	'		Bog=CD/R/2
	'		If Bog>1 Then
	'			Msgbox ("Radius Too Small","Data Corrupt",cMsgboxOK,cMsgboxExclamation)
	'			j=-999999
	'			Return
	'		End If
	'		Engine.CK008(Bog,4 )
	'		Bog=ZCK :Bog=Bog+Bog :Bog=(Main.Rad*(Bog))*R :SV1=SV1+Bog :EIN(j+5)=COD
	'	End If
	End If
End Sub

Public Sub CalcVertical(SV2)
	Dim grade1,grade2,tempe,tempe1
	
	lclevel = -999999 :sv=Int(sv*1000)/1000
	If Data.Numbver=1 Then
		lclevel=Data.WK2(2,1)
		Return
	Else
		For i =1 To Data.Numbver - 1
			If SV2 >= Data.WK2(1,i) AND SV2 <= Data.WK2(1,i + 1) Then
				grade1=(Data.WK2(2,i+1)-Data.WK2(2,i))/(Data.WK2(1,i+1)-Data.WK2(1,i))
				lclevel = Data.WK2(2,i) + (grade1 * (SV2 - Data.WK2(1,i)))
	      		If Int(Data.WK2(3,i)*1000) => 0 AND Int(Data.WK2(4,i)*1000) = 0 Then 'symmetrical vertical curve
					grade1=(Data.WK2(2,i)-Data.WK2(2,i-1))/(Data.WK2(1,i)-Data.WK2(1,i-1))
					grade2=(Data.WK2(2,i+1)-Data.WK2(2,i))/(Data.WK2(1,i+1)-Data.WK2(1,i))
					If SV2 < Data.WK2(1,i)+Data.WK2(3,i)/2  AND SV2 >=Data.WK2(1,i) Then
						lclevel = Data.WK2(2,i) + (grade1 * (SV2 - Data.WK2(1,i)))
						lclevel = lclevel + (((grade2*100) - (grade1*100)) * ((SV2 - (Data.WK2(1,i)-Data.WK2(3,i)/2)) ^ 2)) / (200 * Data.WK2(3,i))
          			Else If SV2 > Data.WK2(1,i+1)-Data.WK2(3,i+1)/2  AND SV2<=Data.WK2(1,i+1) Then
						grade1=(Data.WK2(2,i+1)-Data.WK2(2,i))/(Data.WK2(1,i+1)-Data.WK2(1,i))
						grade2=(Data.WK2(2,i+2)-Data.WK2(2,i+1))/(Data.WK2(1,i+2)-Data.WK2(1,i+1))
						lclevel = Data.WK2(2,i) + (grade1 * (SV2 - (Data.WK2(1,i))))
		            	lclevel = lclevel + (((grade2*100) - (grade1*100)) * ((SV2 - (Data.WK2(1,i+1)-Data.WK2(3,i+1)/2)) ^ 2)) / (200 * Data.WK2(3,i+1))
		         	End If
		      	Else If Int(Data.WK2(3,i)*1000) > 0 AND Int(Data.WK2(4,i)*1000) > 0 Then
	          		If SV2 <= Data.WK2(1,i)+Data.WK2(4,i) AND (Data.WK2(3,i)+Data.WK2(4,i)) > 0 Then
						grade1=(Data.WK2(2,i)-Data.WK2(2,i-1))/(Data.WK2(1,i)-Data.WK2(1,i-1))
						grade2=(Data.WK2(2,i+1)-Data.WK2(2,i))/(Data.WK2(1,i+1)-Data.WK2(1,i))
						tempe = ((Data.WK2(3,i) * Data.WK2(4,i)) / (2 * (Data.WK2(3,i) + Data.WK2(4,i)))) * (grade2 - grade1)
						tempe1 = (((( Data.WK2(1,i)+Data.WK2(4,i)) - SV2) / Data.WK2(4,i)) ^ 2) * tempe / 100
						lclevel = lclevel + tempe1
               		Else If SV2 > Data.WK2(1,i+1)-Data.WK2(3,i+1) AND (Data.WK2(3,i + 1) + Data.WK2(4,i + 1)) > 0 Then
						grade1=(Data.WK2(2,i+1)-Data.WK2(2,i))/(Data.WK2(1,i+1)-Data.WK2(1,i))
						grade2=(Data.WK2(2,i+2)-Data.WK2(2,i+1))/(Data.WK2(1,i+2)-Data.WK2(1,i+1))
						lclevel = Data.WK2(2,i) + (grade1 * (SV2 - (Data.WK2(1,i))))
						tempe = (Data.WK2(3,i + 1) * Data.WK2(4,i + 1)) / (2 * (Data.WK2(3,i + 1) + Data.WK2(4,i + 1))) * (grade2 - grade1)
						tempe1 = (((SV2-( Data.WK2(1,i+1)-Data.WK2(3,i+1)))/ Data.WK2(3,i+1)) ^ 2) * tempe / 100
						lclevel = lclevel + tempe1
	         		End If
            	End If
		      	Return
		  	End If
		Next i	
	End If
End Sub

Public Sub CalcDesignWidth(SV2)
	lwidth=0 :rwidth=0
	SV2=Int(SV2*1000)/1000
	If Data.NumbDesignWidth=1 Then
		lwidth=Data.WK2(2,1001)
		rwidth=Data.WK2(3,1001)
		Return
	Else
		For i=1 To Data.NumbDesignWidth
			If SV2>=Data.WK2(1,i+1000) AND SV2<=Data.WK2(1,i+1001) Then
				lwidth=Data.WK2(2,i+1000)+((SV2-Data.WK2(1,i+1000))*(Data.WK2(2,i+1001)-Data.WK2(2,i+1000))/(Data.WK2(1,i+1001)-Data.WK2(1,i+1000)))
				rwidth=Data.WK2(3,i+1000)+((SV2-Data.WK2(1,i+1000))*(Data.WK2(3,i+1001)-Data.WK2(3,i+1000))/(Data.WK2(1,i+1001)-Data.WK2(1,i+1000)))
				Return
			End If
		Next
	End If
End Sub

Public Sub CalcEdgeShift(SV2)
	ledgew=0 :ledgeh=0
	redgew=0 :redgeh=0
	SV2=Int(SV2*1000)/1000
	If Data.NumbEdgeShift=1 Then
		ledgew=Data.WK2(2,1501) :ledgeh=Data.WK2(3,1501)
		redgew=Data.WK2(4,1501) :redgeh=Data.WK2(5,1501)
		Return
	Else
		For i=1 To Data.NumbEdgeShift
			If SV2>=Data.WK2(1,i+1500) AND SV2<=Data.WK2(1,i+1501) Then
				ledgew=Data.WK2(2,i+1500)+((SV2-Data.WK2(1,i+1500))*(Data.WK2(2,i+1501)-Data.WK2(2,i+1500))/(Data.WK2(1,i+1501)-Data.WK2(1,i+1500)))
				ledgeh=Data.WK2(3,i+1500)+((SV2-Data.WK2(1,i+1500))*(Data.WK2(3,i+1501)-Data.WK2(3,i+1500))/(Data.WK2(1,i+1501)-Data.WK2(1,i+1500)))
				redgew=Data.WK2(4,i+1500)+((SV2-Data.WK2(1,i+1500))*(Data.WK2(4,i+1501)-Data.WK2(4,i+1500))/(Data.WK2(1,i+1501)-Data.WK2(1,i+1500)))
				redgeh=Data.WK2(5,i+1500)+((SV2-Data.WK2(1,i+1500))*(Data.WK2(5,i+1501)-Data.WK2(5,i+1500))/(Data.WK2(1,i+1501)-Data.WK2(1,i+1500)))
				Return
			End If
		Next
	End If
End Sub

Public Sub CalcShoulder(SV2)
	lshw=0 :lshcross=0
	rshw=0 :rshcross=0
	SV2=Int(SV2*1000)/1000
	If Data.NumbShoulder=1 Then
		lshw=Data.WK2(2,2001) :lshcross=Data.WK2(3,2001)
		rshw=Data.WK2(4,2001) :rshcross=Data.WK2(5,2001)
		Return
	Else
		For i=1 To Data.NumbShoulder
			If SV2>=Data.WK2(1,i+2000) AND SV2<=Data.WK2(1,i+2001) Then
				lshw=Data.WK2(2,i+2000)+((SV2-Data.WK2(1,i+2000))*(Data.WK2(2,i+2001)-Data.WK2(2,i+2000))/(Data.WK2(1,i+2001)-Data.WK2(1,i+2000)))
				lshcross=Data.WK2(3,i+2000)+((SV2-Data.WK2(1,i+2000))*(Data.WK2(3,i+2001)-Data.WK2(3,i+2000))/(Data.WK2(1,i+1501)-Data.WK2(1,i+2000)))
				rshw=Data.WK2(4,i+2000)+((SV2-Data.WK2(1,i+2000))*(Data.WK2(4,i+2001)-Data.WK2(4,i+2000))/(Data.WK2(1,i+2001)-Data.WK2(1,i+2000)))
				rshcross=Data.WK2(5,i+2000)+((SV2-Data.WK2(1,i+2000))*(Data.WK2(5,i+2001)-Data.WK2(5,i+2000))/(Data.WK2(1,i+2001)-Data.WK2(1,i+2000)))
				Return
			End If
		Next
	End If
End Sub

Public Sub CalcCrossfall(SV2)
	lcrossfall=0 :rcrossfall=0
	SV2=Int(SV2*1000)/1000
	If Data.NumbCrossfall=1 Then
		lcrossfall=Data.WK2(2,501)
		rcrossfall=Data.WK2(3,501)
		Return
	Else
		For i=1 To Data.NumbCrossfall
			If SV2>=Data.WK2(1,i+500) AND SV2<=Data.WK2(1,i+501) Then
				lcrossfall=Data.WK2(2,i+500)+((SV2-Data.WK2(1,i+500))*(Data.WK2(2,i+501)-Data.WK2(2,i+500))/(Data.WK2(1,i+501)-Data.WK2(1,i+500)))
				rcrossfall=Data.WK2(3,i+500)+((SV2-Data.WK2(1,i+500))*(Data.WK2(3,i+501)-Data.WK2(3,i+500))/(Data.WK2(1,i+501)-Data.WK2(1,i+500)))
				Return
			End If
		Next
	End If
End Sub

Public Sub CalcStakeOffset(SV2)
	StakeOffset=0
	SV2=Int(SV2*1000)/1000
	If Data.NumbStake=1 Then
		StakeOffset=Data.WK2(2,2501)
		Return
	Else
		For i=1 To Data.NumbStake
			If SV2>=Data.WK2(1,i+2500) AND SV2<=Data.WK2(1,i+2501) Then
				StakeOffset=Data.WK2(2,i+2500)+((SV2-Data.WK2(1,i+2500))*(Data.WK2(2,i+2501)-Data.WK2(2,i+2500))/(Data.WK2(1,i+2501)-Data.WK2(1,i+2500)))
				Return
			End If
		Next
	End If
End Sub

Public Sub CalcGradeOffset(SV2)
	GradeOffset=0 :GradeShift=0
	SV2=Int(SV2*1000)/1000
	If Data.NumbGrade=1 Then
		GradeOffset=Data.WK2(2,3001)
		GradeShift=Data.WK2(3,3001)
		Return
	Else
		For i=1 To Data.NumbGrade
			If SV2>=Data.WK2(1,i+3000) AND SV2<=Data.WK2(1,i+3001) Then
				GradeOffset=Data.WK2(2,i+3000)+((SV2-Data.WK2(1,i+3000))*(Data.WK2(2,i+3001)-Data.WK2(2,i+3000))/(Data.WK2(1,i+3001)-Data.WK2(1,i+3000)))
				GradeShift=Data.WK2(3,i+3000)+((SV2-Data.WK2(1,i+3000))*(Data.WK2(3,i+3001)-Data.WK2(3,i+3000))/(Data.WK2(1,i+3001)-Data.WK2(1,i+3000)))
				Return
			End If
		Next
	End If
End Sub

Public Sub CalcLevel(Code,SV2,Side,Offset1,A)
	If SV2<>"" Then
		CalcVertical(SV2)
		'check whether stake Is inside limits
		If lclevel = -999999 AND Code<>15 Then
			Msgbox("Stake Value Is Outside Job Limits","Stake Value",cMsgboxOK,cMsgboxExclamation)
			Return
		End If
		CalcDesignWidth(SV2)
		CalcCrossfall(SV2)
		CalcStakeOffset(SV2)
		CalcGradeOffset(SV2)
		lclevel=lclevel+GradeShift
		llevel=lclevel+(lwidth*lcrossfall/100)
		rlevel=lclevel+(rwidth*rcrossfall/100)
		If Code=1 Then
			'design width
			llevel=lclevel+((lwidth+Main.lo(1))*lcrossfall/100)
			rlevel=lclevel+((rwidth+Main.lo(2))*rcrossfall/100)
			If Side="Left" Then
				rlevel=lclevel+((lwidth+Main.lo(1))*(0-rcrossfall)/100)
				lwidth=0-(lwidth+Main.lo(1)+(0-StakeOffset))
				blevel=llevel+Main.tv(1)-Main.ly(1) :tlevel=rlevel+Main.tv(1)-Main.ly(1)
			Else If Side="Right" Then
				llevel=lclevel+((rwidth+Main.lo(2))*(0-lcrossfall)/100)
				lwidth=rwidth+Main.lo(2)+StakeOffset
				blevel=rlevel+Main.tv(2)-Main.ly(2) :tlevel=llevel+Main.tv(2)-Main.ly(2)
				lcrossfall=rcrossfall
			End If
		Else If Code=2 Then
			'*************************************************************************************edge shift
			CalcEdgeShift(SV2)
			If Side="Left" Then
				lwidth=0-(lwidth+ledgew+Main.lo(1)+(0-StakeOffset))
				blevel=llevel+ledgeh+Main.tv(1)-Main.ly(1)  
			Else If Side="Right" Then
				lwidth=rwidth+redgew+Main.lo(2)+StakeOffset
				blevel=rlevel+redgeh+Main.tv(2)-Main.ly(2) 
			End If
			tlevel=blevel
		Else If Code=3 Then
			'*************************************************************************************shoulder
			CalcEdgeShift(SV2)
			CalcShoulder(SV2)
			lwidth=(lwidth+ledgew+lshw+Main.lo(1)+(0-StakeOffset))
			llevel=llevel+ledgeh+((lshw+Main.lo(1))*lshcross/100)  
			rwidth=rwidth+redgew+rshw+Main.lo(2)+StakeOffset
			rlevel=rlevel+redgeh+((rshw+Main.lo(2))*rshcross/100) 
			If Side="Left" Then
				rlevel=rlevel+((lwidth + rwidth)*(0-rshcross)/100)
				lwidth=0-(lwidth+(0-StakeOffset))
				blevel=llevel+Main.tv(1)-Main.ly(1) :tlevel=rlevel+Main.tv(1)-Main.ly(1)
				lcrossfall=lshcross
			Else If Side="Right" Then
				llevel=llevel+((lwidth+rwidth)*(0-lshcross)/100)
				lwidth=rwidth+StakeOffset
				blevel=rlevel+Main.tv(2)-Main.ly(2) :tlevel=llevel+Main.tv(2)-Main.ly(2)
				lcrossfall=rshcross
			End If
		Else If Code=4 Then
			'calc Appendage
		Else If Code=5 OR Code=6 OR Code=7 OR Code=15 Then
			'5=stake & offset  on design ;6=stake & offset  on full design; 7=check yxz to SV2/offset
			Offset1=Int(Offset1*1000)/1000
			llevel=lclevel+((Offset1+StakeOffset)*(lcrossfall/100))
			rlevel=lclevel+((Offset1-StakeOffset)*(rcrossfall/100))
			If Side="Left" Then
				'left
				If (Offset1<=lwidth+(0-StakeOffset) AND code=6) OR Code=5 OR Code=7 OR Code=15 Then
					blevel=llevel+Main.tv(1)-Main.ly(1) 
					rlevel=lclevel+(Offset1*((0-rcrossfall)/100))
					tlevel=rlevel+Main.tv(1)-Main.ly(1)
					lwidth=offset1+(0-StakeOffset) :Pos="D"
				Else
					'check if inside edge shift
					llevel=lclevel+(lwidth*(lcrossfall/100))
					rlevel=lclevel+(rwidth*(rcrossfall/100))
					CalcEdgeShift(SV2)
					lwidth=lwidth+ledgew+(0-StakeOffset) :Pos="E"
					If Offset1<=lwidth Then
						blevel=llevel+ledgeh-((ledgeh/ledgew)*(lwidth-Offset1))+Main.tv(1)-Main.ly(1)
				  	Else
				  		' check if inside shoulder
						CalcShoulder(SV2)
						lwidth=lwidth+lshw :Pos="S"
						If Offset1<=lwidth Then
							blevel=llevel+ledgeh+((Offset1-lwidth+lshw)*lshcross/100) + Main.tv(1) - Main.ly(1)  
						Else
							blevel="-999999"
						End If
					End If
				End If
			Else If Side="Right" Then
				'right
				If (Offset1<=rwidth+StakeOffset AND code=6) OR Code=5 OR Code=7 OR Code=15 Then
					llevel=llevel+((Offset1*2)*(lcrossfall)/100)
					blevel=rlevel+Main.tv(2)-Main.ly(2) ':tlevel=llevel+Main.tv(2)-Main.ly(2)
					tlevel=lclevel+(Offset1*((0-lcrossfall)/100))+Main.tv(2)-Main.ly(2)
					lCrossfall=rcrossfall
					lwidth=offset1+StakeOffset :Pos="D"
				Else
					'check if inside edge shit
					llevel=lclevel+(lwidth*(lcrossfall/100))
					rlevel=lclevel+(rwidth*(rcrossfall/100))
					CalcEdgeShift(SV2)
					lwidth=rwidth+redgew+StakeOffset :Pos="E"
					If Offset1<=lwidth Then
						blevel=rlevel+redgeh-((redgeh/redgew)*(lwidth-Offset1))+Main.tv(2) -Main.ly(2)
					Else
						'check if inside shoulder
						CalcShoulder(SV2)
						lwidth=lwidth+rshw :Pos="S"
						If Offset1<=lwidth Then
							blevel=rlevel+redgeh+((Offset1-lwidth+rshw)*rshcross/100) + Main.tv(2) - Main.ly(2)  
						Else
							blevel="-999999"
						End If
					End If
				End If
			End If
		End If
	End If	
End Sub

Public Sub YXZToSV(Y4,X4)    '***********************************************
	Dim e,e1,e2,e3,e4,e5,e6,e7,e8,e9,e10,e11,Seite
	
	e=999999999 :e1=0 :jj=0
	SV=0 :OF=0
	
	If Data.numbalign=0 Then
		'no solution found
		Msgbox("There Are No Alignment Points","No Alignment Points",cMsgboxOK,cMsgboxExclamation)
		jj=-999999
		Return
	End If

	For j=1 To Data.numbalign-1
		CK006(Data.WK2(1,j+3500),Data.WK2(2,j+3500),Data.WK2(1,j+3501),Data.WK2(2,j+3501),1)
		e2=CD :e3=CB
		'CK006(Data.WK2(1,j+3500),Data.WK2(2,j+3500),Y4,X4,1)
		'e4=CB-e3
		i = ((Y4 - Data.WK2(1,j+3500)) * (Data.WK2(2,j+3501) - Data.WK2(2,j+3500))) - ((Data.WK2(1,j+3501) - Data.WK2(1,j+3500)) * (X4 - Data.WK2(2,j+3500)))
		If i => 0 Then Seite= -1 Else Seite= 1
		e5=e3+(Seite*90)
		If e5>360 Then e5=e5-360 
		If e5<0 Then e5=360+e5
		CK096(Data.WK2(1,j+3500),Data.WK2(2,j+3500),e3,Y4,X4,e5,0,0,0,5)
		CK006(Data.WK2(1,j+3500),Data.WK2(2,j+3500),Y,X,1)
		e9=CD
		CK006(Y,X,Data.WK2(1,j+3501),Data.WK2(2,j+3501),1)
		If Abs(CD+e9-e2)<0.1 Then
			CK006(Y4,X4,Y,X,1)
			If CD<e  Then
				e=CD :e1=j :e8=Seite 
				e6=Y :e7=X
			End If
		End If
	Next
	If e1=0 OR e>9999 Then
		'no solution found
		Msgbox("Cannot Find A Solution","No Solution",cMsgboxOK,cMsgboxExclamation)
		jj=-999999
		Return
	Else
		If Int(Data.WK2(5,e1+3501))=0 Then
			'OF=e*e8*(0-Seite)
			OF=e*(0-e8)
			CK006(Data.WK2(1,e1+3500),Data.WK2(2,e1+3500),e6,e7,1)
			SV=CD+Data.WK2(6,e1+3500)
		Else If Data.WK2(5,e1+3501)=0.1  Then
			'is on a curve
			CK006(Data.WK2(1,e1+3499),Data.WK2(2,e1+3499),Data.WK2(1,e1+3500),Data.WK2(2,e1+3500),1)
			If Int(Data.WK2(3,e1+3501))<=0 Then e11=-1 Else e11=1
			CB=CB+(90*e11)
			If CB>360 Then CB=CB-360
			If CB<0 Then CB=360+CB
			CK006(Data.WK2(1,e1+3500),Data.WK2(2,e1+3500),CB,Abs(Data.WK2(3,e1+3501)),2)
			CK006(Y2,X2,Y4,X4,1)
			e9=CB
			CD=CD-Abs(Data.WK2(3,e1+3501))
			OF=CD*(0-Seite)
			CK006(Y2,X2,Data.WK2(1,e1+3500),Data.WK2(2,e1+3500),1)
			e10=e9-CB
			If e10<-180 Then e10=360+e10
			If e10>180 Then e10=360-e10
			e10=Abs(e10)
			SV=Data.WK2(6,e1+3500)+((Main.Rad*e10)*Abs(Data.WK2(3,e1+3501)))
		End If
	End If
End Sub

Public Sub CalcYXZ(SV2,Offset)
	Dim e,e1,e2,e3,e11
	
	'This calcs all the BC's and EC's from the horizontal alignment
	
	jj=0
	If Data.numbalign=0 Then
		'no solution found
		Msgbox("There Are No Alignment Points","No Alignment Points",cMsgboxOK,cMsgboxExclamation)
		jj=-999999
		Return
	End If
	
	For j=1 To Data.numbalign-1
		If Int(SV2*1000)/1000>=Data.WK2(6,j+3500) AND Int(SV2*1000)/1000<=Data.WK2(6,j+3501) Then
			If Int(Abs(Data.WK2(3,j+3501)))=0 Then
				'point is on a straight
				CK006(Data.WK2(1,j+3500),Data.WK2(2,j+3500),Data.WK2(1,j+3501),Data.WK2(2,j+3501),1)
				CK006(Data.WK2(1,j+3500),Data.WK2(2,j+3500),CB,Abs(SV2-Data.WK2(6,j+3500)),2)
				If Offset<=0 Then
					CB=CB-90
				Else
					CB=CB+90
				End If
				If CB<=0 Then CB=360+CB
				If CB>360 Then CB=CB-360
				CK006(Y2,X2,CB,Abs(Offset),2)
				'Y2,X2
				Return
			Else
				'point is on a curve
				CK006(Data.WK2(1,j+3499),Data.WK2(2,j+3499),Data.WK2(1,j+3500),Data.WK2(2,j+3500),1)
				If Int(Data.WK2(3,j+3501))<=0 Then e11=-1 Else e11=1
				CB=CB+(90*e11)
				If CB>360 Then CB=CB-360
				If CB<0 Then CB=360+CB
				CK006(Data.WK2(1,j+3500),Data.WK2(2,j+3500),CB,Abs(Data.WK2(3,j+3501)),2)
				'center point of curve
				e=Y2 :e1=X2
				'calc the distance away from the center
				If Data.WK2(3,j+3501)<=0 Then
					'curve is to the left
					e2=Abs(Data.WK2(3,j+3501))+Offset
				Else
					e2=Abs(Data.WK2(3,j+3501))-Offset
				End If
				e3=(SV2-Data.WK2(6,j+3500))/Abs(Data.WK2(3,j+3501))
				e3=e3*Main.Deg
				CB=CB+180
				If CB>360 Then CB=CB-360
				CB=CB+(e11*e3)
				If CB<=0 Then CB=360+CB
				If CB>360 Then CB=CB-360
				CK006(e,e1,CB,e2,2)
				Return
			End If
		End If
	Next
	
End Sub

Public Sub GetBatter(SV2,Side,DLevel,TotWidth)
	Dim BatCond

	If DLevel<0 Then BatCond="Cut" Else BatCond="Fill"
	If Data.numbbat=0 Then
		If Engine.NoBat=1 Then Msgbox ("No Batter Data Has Been Entered" & Chr(13) & "Slopes will default to 1:2", "No Batter Data", cMsgboxOK, cMsgboxExclamation)
		SBPLevel=BLevel
		SBPOffset=Abs(LWidth)
		ToeLevel=Field.OGL
		ToeOffset=SBPOffset+(Abs(DLevel)*2)
		SlopeAngle=(ATan(1/2))*Main.Deg
		SlopeLength=Sqrt(((ToeLevel-SBPLevel)*(ToeLevel-SBPLevel)) + ((ToeOffset-SBPOffset)*(ToeOffset-SBPOffset)))
		Engine.NoBat=0
		Return
	End If
	For i=1 To Data.numbbat
		If SV2>=Data.WK2(3,i+4000) AND Side=Data.WK2(1,i+4000) AND BatCond=Data.WK2(2,i+4000) AND Abs(Dlevel)<=Data.WK2(5,i+4000) Then
			SBPLevel=BLevel-Data.WK2(9,i+4000)
			SBPOffset=Abs(LWidth)+Data.WK2(8,i+4000)
			ToeLevel=Field.OGL
			If Data.WK2(6,i+4000)="Fixed Offset" Then
				ToeOffset=SBPOffset+Data.WK2(7,i+4000)
				SlopeAngle=(ATan(Abs(DLevel)/Data.WK2(7,i+4000)))*Main.Deg
			Else
				ToeOffset=SBPOffset+(Abs(DLevel)*Data.WK2(7,i+4000))
				SlopeAngle=(ATan(1/Data.WK2(7,i+4000)))*Main.Deg
			End If
			SlopeLength=Sqrt(((ToeLevel-SBPLevel)*(ToeLevel-SBPLevel)) + ((ToeOffset-SBPOffset)*(ToeOffset-SBPOffset)))
			Engine.NoBat=0 :Return
		End If
	Next i
	Engine.NoBat=1 :GetBatter(SV2,Side,DLevel,TotWidth)
End Sub

Public Sub CalcPoint(A1,A2,A3,A4,A5,A6)
	Dim H1,V,SD

	Engine.CK008(A1,1) 
	EIN(1)=ZCK
	EIN(1)=EIN(1) + Main.HC                ' add the horizontal correction
	
	Engine.CK008(EIN(1),2) :EIN(1)=ZCK
	Engine.CK008(EIN(1),1) :H1=ZCK 
	Engine.CK008(A2,1) :V=ZCK 
	If A6=1 Then V=V-180
	If V<0 Then V=V+360
	SD=A3
	Engine.CK012(0.0,V,SD,0.0,0.0,0,1)
	Engine.CK006(Main.Y0,Main.X0,H1,HS,2)
	Engine.CK012(0.0,V,Engine.HS,A5,A4,0,2) 
	Z2=Engine.DZ+Main.Z0	
End Sub

Public Sub CK073(Code2,NP1,Flag)
	Dim Sumwt,Wt,Z,V,D,P,Zdz,anz,Num,VV,vb,Dwt
	
	i=0 :Sumwt=0 :Zp=0 :anz=0 :VV=0 :Num=0 :Sdv=0 :Dwt=100
	Do While i<NP1
		i=i+1 :Srt=(i-1)*7
		Z=Field.EIN(Srt+3) 
		Engine.CK008(Field.EIN(Srt+5),1) :V=ZCK
		D=Field.EIN(Srt+6) :P=Field.EIN(Srt+7)
		If Code2=2 Then
			'If P=0 :CONTINUE :ENDIF
			Engine.CK006(Y,X,Field.EIN(Srt+1),Field.EIN(Srt+2),1)
			D=CD 
			Engine.CK012(Z,V,D,P,Main.IH,0,2)
			Zdz=DZ
			'Zdz=-Zdz
		Else If Code2=4 Then
			' If P=0 :CONTINUE :ENDIF
			Engine.CK006(Y,X,Field.EIN(Srt+1),Field.EIN(Srt+2),1)
			D=CD 
			Engine.CK012(Zp,V,D,Main.IH,P,0,2)
			Zdz=DZ
		Else
			'If P=0 AND i>1 AND Code2=22 Then
			'Else
			   Engine.CK012(Zp,V,D,Main.IH,P,1,2)
			   Zdz=DZ
		   'End If
		End If
		If D>0 Then
			Wt=1/((D/Dwt)^2)
			If anz=0 Then
				Sumwt=Sumwt+Wt :Zp=Zp+(Z-Zdz)*Wt 
			End If
		   	If anz=1 Then
		      	If Code2=2 Then 
		         	vb=Zp-Z2
		      	Else
		         	vb=Z-Z2
		      	End If                                           
		      	VV=VV+vb*vb*Wt :Num=Num+1
		   	End If
		End If
	Loop
	i=0
	If Sumwt>0 AND anz=0 Then
	   Zp=Zp/Sumwt 
   	End If
	If Flag=0 OR NP=1 Then
		Return
	Else If Flag>=1 Then
		anz=anz+1
		If anz=1 Then
      		Do While i<NP1
      			i=i+1 :Srt=(i-1)*7
      			Z=Field.EIN(Srt+3) 
      			Engine.CK008(Field.EIN(Srt+5),1) :V=ZCK
      			D=Field.EIN(Srt+6) :P=Field.EIN(Srt+7)
      			If Code2=2 Then
					'If P=0 :CONTINUE :ENDIF
					Engine.CK006(Y,X,Field.EIN(Srt+1),Field.EIN(Srt+2),1)
					D=CD 
					Engine.CK012(Z,V,D,P,Main.IH,0,2)
					Zdz=HS
					'Zdz=-Zdz
				Else If Code2=4 Then
					' If P=0 :CONTINUE :ENDIF
					Engine.CK006(Y,X,Field.EIN(Srt+1),Field.EIN(Srt+2),1)
					D=CD 
					Engine.CK012(Zp,V,D,Main.IH,P,0,2)
					Zdz=HS
				Else
					If P=0 AND i>1 AND Code2=22 Then
					Else
						Engine.CK012(Zp,V,D,Main.IH,P,1,2)
						Zdz=HS
					End If
				End If
				If Int(D)<>0 Then
					Wt=1/((D/Dwt)^2)
					If anz=0 Then
						Sumwt=Sumwt+Wt :Zp=Zp+(Z-Zdz)*Wt 
					End If
					If anz=1 Then
						If Code2=2 Then 
							vb=Zp-Z2
						Else
							vb=Z-Z2
						End If                                           
						VV=VV+vb*vb*Wt :Num=Num+1
					End If
				End If
      		Loop
		End If
		If Num>1 Then Sdv=(Sqrt(VV/(Num-1)))*1000
		mz=Sdv
	End If
End Sub

Public Sub CK080
	Dim Pr,IPT,F1(20),ND,eflg
	Dim Ztpt,IRIM(20),epsi,delta,dism
	Dim H1,H2,H3,V1,Srt
	
	'PS0::
	Maxpt=10 :Minpt=3 :ND=7 :eflg=0
	i=3 
	If Field.IR<>4  Then
		Minpt=2 
	End If
	IPT=Field.Srt-1
	If Field.IR=2 Then      
	   'intersection
		dism=1 
	Else If Field.IR=3 Then 
		dism=2
	Else If Field.IR=4 Then
	   'resection
		dism=1
	Else If Field.IR=22 Then
	   'eccentric
		dism=3 
	End If
	If Field.IR=22 Then
	   '*****************************************************************eccentric setup
		i=1 :Srt=0 :Ztpt=0 :D2=Field.EIN(Srt+6) :P=Field.EIN(Srt+7)
		If D2<>0 Then
		   D1=D2 :Ztpt=1 
	   	End If
		Do While i<=IPT 
			Srt=(i-1)*7 :IRIM(i)=Field.EIN(Srt+4) :i=i+1 
		Loop
		Engine.CK008(Field.EIN(Ztpt*7-3),1) :H1=ZCK 
		Field.EIN(Ztpt*7-3)=1E20 
		Engine.CK008(Field.EIN(Ztpt*7-2),1) :V1=ZCK
		Y=Field.EIN(Ztpt*7-6) :X=Field.EIN(Ztpt*7-5)
		Engine.CK012(0.0,V1,D1,0.0,0.0,0,1) :D1=HS
		i=1
		Do While i<=IPT
			Srt=(i-1)*7
			If i<>Ztpt Then
		      	Field.EIN(Srt+3)=0.0 :Engine.CK008(Field.EIN(Srt+4),1) :epsi=ZCK-H1
				If epsi<0 Then
					epsi=epsi+360 
				End If
				Engine.CK006(Y,X,Field.EIN(Srt+1),Field.EIN(Srt+2),1) :delta=1E20
				If D1<CD Then
					delta=(D1/CD)*Sin(Main.RAD*(epsi)) :delta=Main.DEG*(ASin(delta)) 
				End If
				If delta=1E20 Then
					Msgbox ("Target Is Closer Than Center", "No Soultion", cMsgboxOK, cMsgboxExclamation)
					Return(-1) 
				End If
				Engine.CK008(Field.EIN(Srt+4),1)
				Field.EIN(Srt+4)=delta+ZCK
				Engine.CK008(Field.EIN(Srt+4),5)
				Field.EIN(Srt+4)=ZCK
				Engine.CK008(Field.EIN(Srt+4),2)
				Field.EIN(Srt+4)=ZCK
			End If
			i=i+1
		Loop
		Engine.CK092(Field.IR,IPT,0,7) :Main.HC=Ori 
		H1=H1+180+Main.HC :Engine.CK008(H1,5) :H1=ZCK
		Engine.CK006(Y,X,H1,D1,2) :Y=Y2 :X=X2
		If Field.CheckBox3.Checked=True Then
			i=1
			Do While i<=IPT 
				Field.EIN(i*7-3)=IRIM(i) :i=i+1 
			Loop
			Field.EIN(Ztpt*7-3)=1E20
		End If
		Return
	End If
	'********************************************************************* resection
	'IR=4=Resection
	'CK067:("Position Data",IPT%,7,F1$,1,1) 
	If Field.IR=2 OR Field.IR=4 Then
		Engine.CK008(EIN(4),1): H1=ZCK
		Engine.CK008(EIN(11),1) :H2=ZCK
		Engine.CK008(EIN(18),1) :H3=ZCK
	End If
	If Field.IR=3 Then
		'V1=CK008:(EIN(5),1) :V2=CK008:(EIN(12),1) :D1=EIN(6) :D2=EIN(13) :D3=0
		'If DF%(4)=2 And DF%(5)=0 And DF%(2)=1 :D1=Abs(EIN(7)-D1)*100 :D2=Abs(EIN(14)-D2)*100 :ENDIF
		'D1=CK012:(0.0,V1,D1,0.0,0.0,0,1) :D2=CK012:(0.0,V2,D2,0.0,0.0,0,1)
		'H1=D1 :H2=D2 :H3=D3
		'CK%(1)=4 :CK%(2)=5 :CK%(3)=6
	End If
	Engine.CK096(EIN(1),EIN(2),H1,EIN(8),EIN(9),H2,EIN(15),EIN(16),H3,IR)
	Main.Y0=Y :Main.X0=X :Main.HC=0 :mo=0 :my=0 :mx=0 :mz=0 :mr=0
	'If IR%=4 And IPT%=Minpt% :HC=CK092:(IR%,IPT%,0,7) :ENDIF
	If IPT>Minpt Then
	   ' :i%=CK087:(IR%,IPT%,Minpt%) :mo=Sdv :
   	End If
	'If i%=-1 :RETURN(i%) :ENDIF
	'PS1A:: 
	If Field.CheckBox2.Checked=True Then 
	   'Calc Height
	   Engine.CK073(Field.IR,IPT,1) :Main.Z0=Zp
	   mz=Sdv
	End If
	HC=0 
	If Field.CheckBox3.Checked=True Then 
	   'Calc Orientation
	   Engine.CK092(Field.IR,IPT,1,7) :Main.HC=Ori
	   mr=Sdv 
	End If
	If IPT>Minpt OR Field.CheckBox2.Checked=True OR Field.CheckBox3.Checked=True Then
	   	If Field.IR=22 AND Field.CheckBox3.Checked=False Then
	     	 Return 
      	End If
		'Engine.CK076(1,1,mo,mr,mf,my,mx,mz,"",Minpt,IPT,Field.IR)
	End If
	'If IR%=2 
	'	ST0$="INTSEC"
	'ElseIf IR%=22 
	'	ST0$="ECCENT"
	'ElseIf IR%=3 
	'	ST0$="TRILAT"
	'ElseIf IR%=4 
	'	ST0$="RESECT"
	'ENDIF
	If IPT>Minpt OR Field.CheckBox2.Checked=True OR Field.CheckBox3.Checked=True Then
	'	If IPT%=Minpt% Or ORI$="F" 
	'		Goto PS2:: 
	'	ENDIF
	   'Calc Residuals
	   Engine.CK094(IR,IPT,7,0)   
	End If
	'If eflg%=1 
	'	ORI$="F" :HC=0 
	'ENDIF
   
End Sub

Public Sub CK092(Code1,NP1,Cd1,ND)
	Dim k,csw,isw,hcc,VV,Sumpt,Zalpt
	
	Ori=0 :csw=0 :isw=0 :i=1 :Sumpt=0 :Zalpt=0
	If Code1=2 Then isw=180
	Do While i<=NP1
		Srt=(i-1)*ND
		If Field.EIN(Srt+4)<>1E20 Then Sumpt=Sumpt+1
		i=i+1
	Loop
	i=1
	Do While i<=NP1
		Srt=(i-1)*ND 
		If Field.EIN(Srt+4)=1E20 Then
		   i=i+1 
	   	Else
			Engine.CK008(Field.EIN(Srt+4),1) :H=ZCK
			Engine.CK006(Y,X,Field.EIN(Srt+1),Field.EIN(Srt+2),1)
			Engine.CK008((CB-H-isw),5) :hcc=ZCK
			Zalpt=Zalpt+1
			If hcc<0 Then
				hcc=360+hcc
			End If	
			If Zalpt=1 Then
				If hcc>350 OR hcc<10 Then csw=30 
			End If
			If csw<>0 Then
				Engine.CK008((hcc+csw),5) :hcc=ZCK 
			End If
			If Zalpt>1 Then
				If Abs(hcc-Ori*Sumpt/(Zalpt-1))>90 Then hcc=hcc+360 
			End If
			Ori=Ori+hcc/Sumpt :i=i+1
		End If
	Loop
	Engine.CK008((Ori-csw),5) :Ori=ZCK
	Engine.CK008(Ori,2) :Ori=ZCK
	If Cd1=0 Then
	   Return
	End If
	i=1 :sdv=0.0 :VV=0.0
	Do While i<=NP1
		Srt=(i-1)*ND 
		If Field.EIN(Srt+4)=1E20 Then
		   	i=i+1 
	   	Else
			Engine.CK006(Y,X,Field.EIN(Srt+1),Field.EIN(Srt+2),1) :csw=CB
			Engine.CK008(Field.EIN(Srt+4),1) :H=ZCK
			Engine.CK008((H+Ori),5) :hcc=ZCK
			Engine.CK008(((csw-hcc)*3600),6) :hcc=ZCK
			VV=VV+hcc*hcc
			i=i+1
	   	End If
	Loop
	If Sumpt>1 Then sdv=Sqrt(VV/(Sumpt-1))
End Sub

Public Sub CK094(Code1,NP1,ND,Ofs)
	Dim k,Fl,Corr,ST
	Dim Fk,Trt,lt
	
	d1=2 :d2=1 :Corr=0.0 :Fl=1 :Fk=1.0
	If Main.DF(10)=1 Then
		'Grades
		Fk=100.0/60.0 :Fk=Fk*Fk*400.0/360.0 
	End If 
	Corr=Main.HC
	If Code1=2 Then
	   	d1=1 :Corr=180.0 :Fl=0
	Else If Code1=3 OR Code1=5 Then
	   	d2=2 :Fl=0
	Else If Code1=4 Then
	   	d1=1 :Fl=0
	Else If Code1=6 Then
	   	d2=3
	Else If Code1>=9 Then
		d1=2 :Fl=0
		If Code1=22 Then d1=1
		If Code1=10 Then Fl=1
	End If
	If Main.DF(4)=1 AND main.DF(2)=1 Then Fl=0
	If Field.Checkbox3.Checked=True OR Code1=5 Then d1=1 
	If Field.Checkbox2.Checked=True Then d2=d2+1
	i=1 :zal=0
	Do While i<=NP1
		If Code1<>6 Then
			Srt=(i-1)*ND 
			ST=EIN1(i) :Y=EIN(Srt+1) :X=EIN(Srt+2) :Z=EIN(Srt+3)
			Engine.CK006(Main.Y0,Main.X0,Y,X,1)
			Engine.CK008(EIN(Srt+4),1) :H=ZCK
			Engine.CK008(EIN(Srt+5),1) :V=ZCK
			D=EIN(Srt+6) :P=EIN(Srt+ND)
			If Code1=2 OR Code1=4 OR Code1=9 Then 
				D=CD
			End If 
		End If
		If (Code1<>3 AND Code1<=5) OR Field.Checkbox3.Checked=True Then
			If H=1E20 Then
			   zal=zal+1 :dsp(zal)=1E20 
		   	Else
				zal=zal+1 
				Engine.CK008((H+Corr),5) :dsp(zal)=ZCK 
				dsp(zal)=(CB-dsp(zal))*3600
				Engine.CK008(dsp(zal),6) :dsp(zal)=ZCK
				dsp(zal)=(dsp(zal))*Fk
			End If
		End If
		If Code1=3 OR Code1=5 Then 
			zal=zal+1
			Engine.CK012(0.0,V,D,0.0,0.0,0,1) :dsp(zal)=HS
			dsp(zal)=(CD-dsp(zal))*1000 :D=CD
		Else If Code1=6 Then 
			Trt=(i-1)*ND+Ofs
			zal=zal+1 :dsp(zal)=EIN(Trt+3) :zal=zal+1 :dsp(zal)=EIN(Trt+4)
		End If
		If Field.Checkbox2.Checked=True Then 
			If Z=0 OR D=0 OR V=0 Then'Or P=0 Then
				zal=zal+1 :dsp(zal)=1E20
			Else
				zal=zal+1
				If Code1=2 Then  
					Engine.CK012(Z,V,D,P,IH,Fl,2)
					dsp(zal)=(Main.Z0-Z2)*1000 
				End If
				If Code1<>2 Then 
					Engine.CK012(Main.Z0,V,D,Main.IH,P,Fl,2)
					dsp(zal)=(Z-Z2)*1000 
				End If
			End If 
		End If
		i=i+1
	Loop
	afp=1 
	If Field.IR=22 Then afp=2
	i=afp
End Sub

Public Sub CK105(Code,NP1,NDO,NDN,Ofs)
   Dim Nsrt,Osrt,Osrs,A,B,C,D,E,F,G,VV1,VV2,Ry,Rx
   
	If Code=1 Then
		Yco=0 :Xco=0 :Ycn=0 :Xcn=0 :i=1
		Do While i<=NP1
			Nsrt=(i-1)*NDO :Osrt=(i-1)*NDN+Ofs
			Yco=Yco+Field.EIN(Osrt+1)/NP1 :Xco=Xco+Field.EIN(Osrt+2)/NP1
			Ycn=Ycn+Field.EIN(Nsrt+1)/NP1 :Xcn=Xcn+Field.EIN(Nsrt+2)/NP1 
			i=i+1
		Loop
		A=0 :B=0 :C=0 :i=1
		Do While i<=NP1
			Nsrt=(i-1)*NDO :Osrt=(i-1)*NDN+Ofs
			D=Field.EIN(Osrt+1)-Yco :E=Field.EIN(Osrt+2)-Xco
			F=Field.EIN(Nsrt+1)-Ycn :G=Field.EIN(Nsrt+2)-Xcn
			A=A+D*D+E*E :B=B+D*F+E*G :C=C+E*F-D*G 
			i=i+1
		Loop
		OG=C/A :AG=B/A 
		Engine.CK006(0.0,0.0,OG,AG,1)
		Tsw=CB :Tfc=CD
	Else If Code=2 Then
		Sdv=0 :i=1
		Do While i<=NP1
			Nsrt=(i-1)*NDO :Osrt=(i-1)*NDN+Ofs
			dy=Field.EIN(Osrt+1)-Yco :dx=Field.EIN(Osrt+2)-Xco
			Ry=Field.EIN(Nsrt+1)-(Ycn+OG*dx+AG*dy) :Rx=Field.EIN(Nsrt+2)-(Xcn+AG*dx-OG*dy)
			EIN(Osrt+3)=Ry*1000 :EIN(Osrt+4)=Rx*1000 :VV1=VV1+Ry*Ry :VV2=VV2+Rx*Rx
			i=i+1
		Loop
		If NP1>2 Then
			Sdv=(Sqrt((VV1+VV2)/(2*NP1-4)))*1000
			my=(Sqrt((VV1)/(2*NP1-4)))*1000 :mx=(Sqrt((VV2)/(2*NP1-4)))*1000
		End If
	Else If Code=3 Then
		dy=Field.Y1-Yco :dx=Field.X1-Xco :Y=Ycn+OG*dx+AG*dy :X=Xcn+AG*dx-OG*dy
	End If
End Sub

#End Region
