﻿version
6.50
0
frmColorPalette
1
bmpColorPalette:BitmapEx
Sub designer
addform(frmColorPalette,"Color select","",220,220,220)@
addimagelist(frmcolorpalette,IL1,95,95,80,25,1,"ColorPalette.bmp",0)@
addtextbox(frmcolorpalette,txtColorPaletteB,160,165,30,22,"",255,255,255,0,0,0,True,True,False,9)@
addtextbox(frmcolorpalette,txtColorPaletteG,90,165,30,22,"",255,255,255,0,0,0,True,True,False,9)@
addtextbox(frmcolorpalette,txtColorPaletteR,30,165,30,22,"",255,255,255,0,0,0,True,True,False,9)@
addtextbox(frmcolorpalette,txtColorPaletteL,160,135,30,22,"",255,255,255,0,0,0,True,True,False,9)@
addtextbox(frmcolorpalette,txtColorPaletteS,90,135,30,22,"",255,255,255,0,0,0,True,True,False,9)@
addtextbox(frmcolorpalette,txtColorPaletteH,30,135,30,22,"",255,255,255,0,0,0,True,True,False,9)@
addlabel(frmcolorpalette,lblColorPaletteB,145,165,20,20,"B",220,220,220,0,0,0,True,True,9)@
addlabel(frmcolorpalette,lblColorPaletteG,75,165,20,20,"G",220,220,220,0,0,0,True,True,9)@
addlabel(frmcolorpalette,lblColorPaletteR,15,165,20,18,"R",220,220,220,0,0,0,True,True,9)@
addlabel(frmcolorpalette,lblColorPaletteL,145,135,20,18,"L",220,220,220,0,0,0,True,True,9)@
addlabel(frmcolorpalette,lblColorPaletteS,75,135,20,18,"S",220,220,220,0,0,0,True,True,9)@
addlabel(frmcolorpalette,lblColorPaletteH,15,135,20,18,"H",220,220,220,0,0,0,True,True,9)@
addimagebutton(frmcolorpalette,btnColorPaletteOK,220,25,15,15,"",212,208,200,0,0,0,"cCenterImage","btnCheckedGW.bmp",False,True,True,9)@
addimagebutton(frmcolorpalette,btnColorPaletteExit,220,5,15,15,"",212,208,200,0,0,0,"cCenterImage","btnExitRW.bmp",False,True,True,9)@
End Sub
@EndOfDesignText@
Sub Globals
' This module lets choose a color in a color palette
' To call the Color Palette use ColorPalette.Show("Main.ReturnColorPalette",col)
' The Main module must have a routine, the color given by the The Color Palette is the variable col 
' Sub ReturnColorPalette(col)
'
' End Sub

'Declare the global variables here.
	Initialized=0
	ReturnTo=""

'	Color palette variables
	X0=0		' x coordinate left  edge H-S diagram
	X1=0		' x coordinate right edge H-S diagram
	X2=0		' x coordinate left  edge  L diagram
	X3=0		' x coordinate right edge  L diagram
	X4=0		' x coordinate left  edge  color image
	X5=0		' x coordinate right edge  color image
	Y0=0		' y coordinate uper  edge diagrams
	Y1=0		' y coordinate lower edge diagrams
	Y2=0		' y coordinate uper  edge of color image
	Y3=0		' y coordinate lower edge of color image
	Y4=0		' y coordinate uper  edge of transparent color image
	Y5=0		' y coordinate lower edge of transparent color image
	Pen=0	' flage if pen is down, for MouseMove routine
	Hue=0		' color Hue value
	Sat=0		' color Saturation value
	Lum=0		' color Lightness value

	HMax=240	' max value for Hue
	SMax=240	' max value for Saturation
	LMax=240	' max value for Lightness
	Width=120		' width of color palette
	Color=0	' selected color
	Private Type(R,G,B) CP  ' color values
	G_R=0
	G_G=0
	G_B=0
	ColTransparent=Rgb(250,250,250)
	Dim DefColor(16)
	DefColor(0)=Rgb(0,0,0)
	DefColor(1)=Rgb(255,255,255)
	DefColor(2)=Rgb(255,0,0)
	DefColor(3)=Rgb(0,255,0)
	DefColor(4)=Rgb(0,0,255)
	DefColor(5)=Rgb(255,255,0)
	DefColor(6)=Rgb(0,255,255)
	DefColor(7)=Rgb(255,0,255)
	DefColor(8)=Rgb(192,192,192)
	DefColor(9)=Rgb(192,0,0)
	DefColor(10)=Rgb(0,192,0)
	DefColor(11)=Rgb(0,0,192)
	DefColor(12)=Rgb(192,192,0)
	DefColor(13)=Rgb(0,192,192)
	DefColor(14)=Rgb(128,128,128)
	DefColor(15)=Rgb(64,64,64)
End Sub

Public Sub Show(ReturnToSub,col)
	ReturnTo=ReturnToSub
	SetTransparentColor(ColTransparent)
	frmColorPalette.ForeLayer=True

	If Initialized=0 Then
		Init
		Initialized=1 
	End If
	
	CP()=GetRGB(col)
	UpdateParam(1)
	frmColorPalette.Show
End Sub

Public Sub Init
	Dim T,S,Col
	
	bmpColorPalette.New3(IL1.Item(0))  'ColorPalette.bmp ' bitmap control

	X0=10
	X1=X0+Width
	Y0=10
	Y1=Y0+Width
	frmColorPalette.DrawImage(bmpColorPalette.Value,9,9)
	X2=X1+20
	X3=X2+20
	frmColorPalette.Line(X2-1,Y0-1,X3+1,Y1,cBlack,B)
	X4=X3+20
	X5=X4+20
	Y2=Y0+50
	Y3=Y2+20
	frmColorPalette.Line(X2-1,Y2-1,X3+1,Y3+1,cBlack,B)
	frmColorPalette.Line(X4-1,Y2-1,X5+1,Y3+1,cBlack,B)

	DrawCursor(cBlack)
	DrawLum
	DrawLumCursor(cBlack)
	UpdateColor(0)
	txtColorPaletteH.Text=Hue
	txtColorPaletteS.Text=Sat
	txtColorPaletteL.Text=Lum
	
	For i=0 To 15
		AddImage("frmColorPalette","btnColor"&i,7+i*14,200,12,12)
		Control("btnColor"&i).Color=DefColor(i)
		AddEvent("btnColor"&i,Click,"btnColor_Click")
	Next
End Sub

Sub frmColorPalette_MouseDown (x,y)
	If x>=X0 AND x<=X1 AND y>=Y0 AND y<=Y1 Then
		Pen=1
		UpdateHS(x,y)
		UpdateColor(0)
	End If

	If x>=X2 AND x<=X3+6 AND y>=Y0 AND y<=Y1 Then
		Pen=1
		UpdateLum(x,y)
		UpdateColor(0)
	End If
End Sub

Sub frmColorPalette_MouseMove (x,y)
	If Pen=1 AND x>=X0 AND x<=X1 AND y>=Y0 AND y<=Y1 Then
		UpdateHS(x,y)
		UpdateColor(0)
	End If

	If Pen=1 AND x>=X2 AND x<=X3+6 AND y>=Y0 AND y<=Y1 Then
		UpdateLum(x,y)
		UpdateColor(0)
	End If
End Sub

Sub frmColorPalette_MouseUp (x,y)
	Pen=0
End Sub

Sub UpdateHS(x,y)
	DrawCursor(ColTransparent)
	Hue=(x-X0)*HMax/Width
	Sat=(Width-(y-Y0))*2
	txtColorPaletteH.Text=Hue
	txtColorPaletteS.Text=Sat
	DrawCursor(cBlack)
	DrawLum
End Sub

Sub UpdateLum(x,y)
	DrawLumCursor(ColTransparent)
	Lum=(Width-(y-Y0))*2 
	txtColorPaletteL.Text=Lum
	DrawLumCursor(cBlack)
End Sub

Sub UpdateColor(Mode)
	If Mode=0 Then
		HSLToRGB(Hue,Sat,Lum)
		CP.R=G_R
		CP.G=G_G
		CP.B=G_B
	End If
	txtColorPaletteR.Text=CP.R
	txtColorPaletteG.Text=CP.G
	txtColorPaletteB.Text=CP.B
	Color=Rgb(CP.R,CP.G,CP.B)
	frmColorPalette.Line(X4,Y2,X5+1,Y3+1,CP.R,CP.G,CP.B,BF)
End Sub

Sub UpdateTranspColor
	
	txtColorPaletteR.Text=CP.R
	txtColorPaletteG.Text=CP.G
	txtColorPaletteB.Text=CP.B
	Color=Rgb(CP.R,CP.G,CP.B)
	frmColorPalette.Line(X4,Y2,X5+1,Y3+1,CP.R,CP.G,CP.B,BF)
End Sub

Sub btnColorPaletteOK_Click
	frmColorPalette.Close
	CallSub(ReturnTo,Color)
End Sub

Sub btnColorPaletteExit_Click
	frmColorPalette.Close
	CallSub(ReturnTo,cCancel)
End Sub

Sub btnColor_Click
	Dim i
	
	i=SubString(Sender,8,StrLength(Sender)-8)
	CP()=GetRGB(DefColor(i))
	UpdateParam(1)
End Sub

Public Sub DrawLum
	For I=0 To Width-1
		Col=HSLToRGB(Hue,Sat,(Width-I)*2)
		frmColorPalette.Line(X2,Y0+I,X3,Y0+I,Col)
	Next I
End Sub

Sub DrawCursor(Col)
	x=Hue*Width/HMax+X0
	y=Y1-Sat/2
	frmColorPalette.FLine(x-2,y,x+2,y,Col)
	frmColorPalette.FLine(x,y-2,x,y+2,Col)
End Sub

Sub DrawLumCursor(Col)
	Dim x,y
	
	x=X3+1
	y=Y0+Width-Lum/2
	frmColorPalette.FLine(x+1,y,x+6,y-4,Col)
	frmColorPalette.FLine(x+6,y-4,x+6,y+4,Col)
	frmColorPalette.FLine(x+6,y+4,x+1,y,Col)
End Sub

Public Sub UpdateParam(Mode)
	' Mode = 0    change H,S,L -> R,G,B
	' Mode = 1    change R,G,B -> H,S,L
	
	DrawCursor(ColTransparent)
	DrawLumCursor(ColTransparent)
	If Mode=0 Then
		HSLToRGB(Hue,Sat,Lum)
	Else
		RGBToHSL(CP.R,CP.G,CP.B)
	End If
	txtColorPaletteH.Text=Hue
	txtColorPaletteS.Text=Sat
	txtColorPaletteL.Text=Lum
	DrawLum
	DrawLumCursor(cBlack)
	DrawCursor(cBlack)
	UpdateColor(Mode)
End Sub

Sub txtColorPaletteH_LostFocus
	Dim Txt
	
  If IsNumber(txtColorPaletteH.Text)=False OR txtColorPaletteH.Text<0 OR txtColorPaletteH.Text>HMax Then
		If IsNumber(txtColorPaletteH.Text)=False Then
'			Txt=Text(28)&CRLF&Text(29)
		Else
'			Txt=Text(28)&CRLF&Text(30)&" "&HMax
		End If
'		Msgbox(Txt,Text(9),cMsgboxOK,cMsgboxExclamation)
		txtColorPaletteH.Focus
	Else
		DrawCursor(ColTransparent)
		DrawLumCursor(ColTransparent)
		Hue=txtColorPaletteH.Text
		UpdateParam(0)
	End If
End Sub

Sub txtColorPaletteS_LostFocus
	Dim Txt
	
  If IsNumber(txtColorPaletteS.Text)=False OR txtColorPaletteS.Text<0 OR txtColorPaletteS.Text>SMax Then
		If IsNumber(txtColorPaletteS.Text)=False Then
'			Txt=Text(28)&CRLF&Text(29)
		Else
'			Txt=Text(28)&CRLF&Text(30)&" "&CP_SMax
		End If
'		Msgbox(Txt,Text(9),cMsgboxOK,cMsgboxExclamation)
		txtColorPaletteS.Focus
	Else
		DrawCursor(ColTransparent)
		DrawLumCursor(ColTransparent)
		Sat=txtColorPaletteS.Text
		UpdateParam(0)
	End If
End Sub

Sub txtColorPaletteL_LostFocus
	Dim Txt
	
  If IsNumber(txtColorPaletteL.Text)=False OR txtColorPaletteL.Text<0 OR txtColorPaletteL.Text>LMax Then
		If IsNumber(txtColorPaletteL.Text)=False Then
'			Txt=Text(28)&CRLF&Text(29)
		Else
'			Txt=Text(28)&CRLF&Text(30)&" "&CP_LMax
		End If
'		Msgbox(Txt,Text(9),cMsgboxOK,cMsgboxExclamation)
		txtColorPaletteL.Focus
	Else
		DrawCursor(ColTransparent)
		DrawLumCursor(ColTransparent)
		Lum=txtColorPaletteL.Text
		UpdateParam(0)
	End If
End Sub

Sub txtColorPaletteR_LostFocus
	Dim Txt
	
  If IsNumber(txtColorPaletteR.Text)=False OR txtColorPaletteR.Text<0 OR txtColorPaletteR.Text>255 Then
		If IsNumber(txtColorPaletteR.Text)=False Then
'			Txt=Text(28)&CRLF&Text(29)
		Else
'			Txt=Text(28)&CRLF&Text(30)&" 255"
		End If
'		Msgbox(Txt,Text(9),cMsgboxOK,cMsgboxExclamation)
		txtColorPaletteR.Focus
	Else
		CP.R=txtColorPaletteR.Text
		UpdateParam(1)
	End If
End Sub

Sub txtColorPaletteG_LostFocus
	Dim Txt
	
  If IsNumber(txtColorPaletteG.Text)=False OR txtColorPaletteG.Text<0 OR txtColorPaletteG.Text>255 Then
		If IsNumber(txtColorPaletteG.Text)=False Then
'			Txt=Text(28)&CRLF&Text(29)
		Else
'			Txt=Text(28)&CRLF&Text(30)&" 255"
		End If
'		Msgbox(Txt,Text(9),cMsgboxOK,cMsgboxExclamation)
		txtColorPaletteG.Focus
	Else
		CP.G=txtColorPaletteG.Text
		UpdateParam(1)
	End If
End Sub

Sub txtColorPaletteB_LostFocus
	Dim Txt
	
  If IsNumber(txtColorPaletteB.Text)=False OR txtColorPaletteB.Text<0 OR txtColorPaletteB.Text>255 Then
		If IsNumber(txtColorPaletteB.Text)=False Then
'			Txt=Text(28)&CRLF&Text(29)
		Else
'			Txt=Text(28)&CRLF&Text(30)&" 255"
		End If
'		Msgbox(Txt,Text(9),cMsgboxOK,cMsgboxExclamation)
		txtColorPaletteB.Focus
	Else
		CP.B=txtColorPaletteB.Text
		UpdateParam(1)
	End If
End Sub

Sub RGBToHSL(R,G,B)
	Dim T0,M0,M1,D
	Dim CP_H1_6,CP_H1_3,CP_H2_3
	
	M1=Max(R,G)
	M1=Max(M1,B)
	
	M0=Min(R,G)
	M0=Min(M0,B)
	
	D=M1-M0
	
	CP_H1_6=HMax/6
	CP_H1_3=HMax/3
	CP_H2_3=CP_H1_3*2
	
	If M1=M0 Then
		Hue=0
	Else If M1=R AND G>=B Then 
		Hue=Int(CP_H1_6*(G-B)/D)
	Else If M1=R AND G<B Then
		Hue=Int(CP_H1_6*(G-B)/D)+HMax  '360 / 240
	Else If M1=G Then
		Hue=Int(CP_H1_6*(B-R)/D)+CP_H1_3 '120 / 80
	Else
		Hue=Int(CP_H1_6*(R-G)/D)+CP_H2_3 ' 240 / 160
	End If
	
	Lum=Int((M1+M0)*LMax/2/255)
	
	
	If Lum=0 OR M1=M0 Then
		Sat=0
	Else If Lum<=LMax/2 Then
		Sat=D*SMax/(M1+M0)
	Else
		Sat=D*SMax/(510-(M1+M0))
	End If
	
End Sub

Sub HSLToRGB(H,S,L)
	Dim H0,M0,M1,D,i

	' Mode = 0 returns  the values of RGB CP.R,CP.G,CP.B
	'      = 1 returns  the color RGB(R,G,B)
	
	If H=240 Then H=0  ' 240 identical to 0
	
	H0=6*H/HMax
	If L<LMax/2 Then
		M1=Int(255*L/LMax*(1+S/SMax))
		M0=Int(255*L/LMax*(1-S/SMax))
	Else
		M1=Int(255*(L/LMax*(1-S/SMax)+S/SMax))
		M0=Int(255*(L/LMax*(1+S/SMax)-S/SMax))
	End If
	D=M1-M0
	i=Int(H0)

	Select i
	Case 0
		G_B=M0
		G_G=Int(M0+H0*D)
		G_R=M1
	Case 1
		G_B=M0
		G_R=Int(M0+(2-H0)*D)
		G_G=M1
	Case 2
		G_R=M0
		G_B=Int(M0+(H0-2)*D)
		G_G=M1
	Case 3
		G_R=M0
		G_G=Int(M0+(4-H0)*D)
		G_B=M1
	Case 4
		G_G=M0
		G_R=Int(M0+(H0-4)*D)
		G_B=M1
	Case 5
		G_G=M0
		G_B=Int(M0+(6-H0)*D)
		G_R=M1
	End Select
	
	Return Rgb(G_R,G_G,G_B)
End Sub
