﻿Version=6.75
NumberOfForms=2
Form1=Contour
Form2=Stock
NumberOfObjects=1
Object1=d2d:Delaunay2D
Sub designer
addform(Contour,"Contour","",220,220,220)@
addtextbox(contour,TextBox3,110,54,50,22,"",255,255,255,0,0,0,True,True,False,9)@
addtextbox(contour,TextBox2,110,32,75,22,"",255,255,255,0,0,0,True,True,False,9)@
addtextbox(contour,TextBox1,110,10,75,22,"",255,255,255,0,0,0,True,True,False,9)@
addbutton(contour,OKCon,125,238,50,23,"Calc",212,208,200,0,0,0,True,True,9)@
addbutton(contour,ExitCon,176,238,50,23,"Exit",212,208,200,0,0,0,True,True,9)@
addlabel(contour,Label3,8,61,130,17,"Interval....................",220,220,220,0,0,0,True,True,9)@
addlabel(contour,Label2,8,39,130,17,"End Level...............",220,220,220,0,0,0,True,True,9)@
addlabel(contour,Label1,8,17,130,17,"Start Level...............",220,220,220,0,0,0,True,True,9)@
addform(Stock,"Stockpile","",220,220,220)@
addbutton(stock,OK,206,246,30,20,"OK",212,208,200,0,0,0,True,False,9)@
addpanel(stock,Panel1,0,5,230,270,220,220,220,True,True)@
addtable(panel1,Table1,8,5,217,220,"",245,245,245,0,0,0,True,True,9)@
addarraylist(panel1,ypoints,20,50,80,25)@
addarraylist(panel1,xpoints,20,20,80,25)@
addbutton(panel1,ExitList,175,233,50,23,"Exit",212,208,200,0,0,0,True,True,9)@
addlabel(stock,Label4,3,250,225,16,"",255,255,255,0,0,0,True,True,9,False)@
addopendialog(stock,OpenDialog1,95,95,All Files|*.*)@
addmenuitem(stock,Menu16,"File",True,False)@
addmenuitem(menu16,Menu3,"Import",True,False)@
addmenuitem(menu16,Menu4,"-",True,False)@
addmenuitem(menu16,Menu14,"Exit",True,False)@
addmenuitem(stock,Menu2,"Tools",False,False)@
addmenuitem(menu2,Menu17,"List",True,False)@
addmenuitem(menu2,Menu18,"-",True,False)@
addmenuitem(menu2,Menu5,"Tin",True,False)@
addmenuitem(menu2,Menu6,"Edit",True,False)@
addmenuitem(menu6,Menu1,"Swap",True,False)@
addmenuitem(menu6,Menu15,"Erase",True,False)@
addmenuitem(menu2,Menu7,"-",True,False)@
addmenuitem(menu2,Menu8,"Contours",True,False)@
addmenuitem(menu2,Menu9,"-",True,False)@
addmenuitem(menu2,Menu19,"Shading",True,False)@
addmenuitem(menu2,Menu20,"-",True,False)@
addmenuitem(menu2,Menu10,"Boundary",True,False)@
addmenuitem(stock,Menu21,"Qty",False,False)@
addmenuitem(menu21,Menu13,"Area",True,False)@
addmenuitem(menu21,Menu12,"Volume",True,False)@
End Sub
@EndOfDesignText@
#Region *********************************************** General

Sub Globals
	Dim Type (X, Y, Z) Points(0) As Double ' X, Y and Z for each real world point	
	Dim Type (X, Y, Z) PPoints(0) As Int32 ' X, Y and Z for each real world point	
	Dim Type (X, Y, Z) CoOrds(0) As Int32 ' screen X and Y for each points
	Dim Type (X, Y, Z) Boundary(0) As Double ' screen X and Y for boundary line
	Dim Type (X, Y, Z) BBoundary(0) As Double ' screen X and Y for boundary line
	Dim Type (V1, V2, V3) Triangles(0) As Int32 ' triangle vertices are indeces into Points and CoOrds arrays
	Dim Type (V1, V2, V3) BTriangles(0) As Int32 
	Dim Type (X,Y) s1(3) 
	Dim tx(3),ty(3),tz(3)
	Dim bx(3),by(3),bz(3)
	Dim cdrs(10),s2(100),Number,MinX,MaxX,MinY,MaxY,MinZ,MaxZ,Swap,DelTin,YScale,XScale,dx,dy
	Public Bound,Tin,Shade,Contour
	
	'3D View Constants
	Dim t1,t2,t3,t4,p11,p12,p13,p21,p22,p23,Ret,Ein(10),Code	
	XMin1=0 :XMax1=225 :YMin1=0 :YMax1=233
	Tolerance = 5 ' number of pixels away from point treated a hit

	MinX1 = 10	' screen max and min xy CoOrds
	MinY1 = 10
	MaxX1 = 220
	MaxY1 = 235
	
	'3D Constants
	globxrot=0
	globyrot=0
	globzrot=0	

End Sub

Sub DrawBorder(Opt1,color)
	If Opt1=1 Then
    	Contour.Line(2,2,Contour.Width-4,Contour.Height-3,color,b)
	End If
End Sub

#End Region

#Region ************************************* Tin Model

Sub Stock_Show
	Stock.Stock.ForeLayer=True
	Stock.Bound=0 :Stock.Tin=0
	Swap=0 :DelTin=0 :Shade=0 :Contour=0
	OK.Visible=False
	Panel1.Left=300 :Panel1.Top=5
	D2D.New1
End Sub

Sub CountFile
	Number=0
	FileOpen(c2,OpenDialog1.File,cRead) 'opens the specified file
	s = FileRead(c2) 
	Do Until s = EOF 'Read the txt items until end of file.
		s = FileRead(c2) 
		Number=Number+1
	Loop
	FileClose(c2)
End Sub

Sub Menu1_Click
	'Swap triangles
	OK.Visible=False
	If Swap=0 Then Swap=1 Else Swap=0
	DelTin=0 :Bound=0
End Sub

Sub Menu15_Click
	'delete triangles
	OK.Visible=False
	If DelTin=0 Then DelTin=1 Else DelTin=0
	Swap=0 :Bound=0
End Sub

Sub Menu3_Click
	'import points
	OK.Visible=False
	OpenDialog1.Filter = "CSV Files|*.csv|Text Files|*.txt|ASCII Files|*.asc"
	OpenDialog1.Show
	If OpenDialog1.File<>"" Then
		Ein()=StrSplit(OpenDialog1.File,".")
		If StrToUpper(Ein(1))="CSV" Then
			Code=1
		Else If StrToUpper(Ein(1))="TXT" Then
			Code=2
		Else If StrToUpper(Ein(1))="ASC" Then
			Code=3
		End If
		WaitCursor(True)
		Menu2.Enabled=True :Menu21.Enabled=True 
		Swap=0 :Tin=0 :Bound=0 :OK=0
		Stock.Stock.Line(0,0,238,390,cWhite,BF)
		CountFile
		Dim Points(Number,3) As Single
		Dim PPoints(Number,3) As Int32
		Dim BBoundary(Number,3) As Double
		Dim CoOrds(Number+2,3) As Single
		Number=-1 :MinY=9E99 :MaxY=-9E99 :MinX=9E99 :MaxX=-9E99 :MinZ=9E99 :MaxZ=-9E99	'KC
		FileOpen(c2,OpenDialog1.File,cRead) 'opens the specified file
		Do  'Read the txt items until end of file.	'KC
			s = FileRead(c2)
			If s ="@eof@" Then Exit'checks if it is the last entry of the file
			If Code=1 Then
				s2()=StrSplit(s,",")
			Else If Code=2 Then
				s2()=StrSplit(s,"")
			Else
				s2()=StrSplit(s,Chr(9))
			End If
			'Found Nothing
			If ArrayLen(s2())<=1 Then
				s2()=StrSplit(s,",")
			End If
			If ArrayLen(s2())<=1 Then
				s2()=StrSplit(s,"")
			End If
			If ArrayLen(s2())<=1 Then
				s2()=StrSplit(s,Chr(9))
			End If
			If ArrayLen(s2())>1 Then 
				OK=0 :i1=-1
				For i=0 To ArrayLen(s2())-1
					If s2(i)<>"" Then
						i1=i1+1
						cdrs(i1)=StrReplace(s2(i)," ","") 
					End If
				Next i
				If IsNumber(cdrs(0))=False AND IsNumber(cdrs(1))=True Then
					Number=Number+1
					Points(Number).X=cdrs(1)
					Points(Number).Y=cdrs(2)
					Points(Number).Z=cdrs(3)
					OK=1
				Else If IsNumber(cdrs(0))=True AND IsNumber(cdrs(1))=True Then
					Number=Number+1
					Points(Number).X=cdrs(0)
					Points(Number).Y=cdrs(1)
					Points(Number).Z=cdrs(2)
					OK=1
				End If
				If OK=1 Then
					PPoints(Number).X=Points(Number).X
					PPoints(Number).Y=Points(Number).Y
					PPoints(Number).Z=Points(Number).Z
					If Points(Number).X>MaxX Then MaxX=Points(Number).X
					If Points(Number).X<MinX Then MinX=Points(Number).X
					If Points(Number).Y>MaxY Then MaxY=Points(Number).Y
					If Points(Number).Y<MinY Then MinY=Points(Number).Y
					If Points(Number).Z>MaxZ Then MaxZ=Points(Number).Z
					If Points(Number).Z<MinZ Then MinZ=Points(Number).Z
				End If
			End If
		Loop Until s ="@eof@"
		FileClose(c2)
		For i=0 To Number
			Points(i).X=MaxX-Points(i).X :Points(i).Y=MaxY-Points(i).Y
		Next i
		OK=0
		CoOrds() = D2D.PointsToScreen(220, 10, 10,240, Points())
		YScale=238/(Abs(MaxY-MinY)*1.1) :XScale=225/(Abs(MaxX-MinX)*1.1) 
		PlotPoints
		WaitCursor(False)
	End If
End Sub

Sub Menu5_Click
	'create tin model
	If Tin=1 Then Tin=0 Else Tin=1
	If Number>2 Then
		OK.Visible=False
		Swap=0 
		Triangles() = D2D.TriangulatePoints(Points())
		PlotPoints
	Else
		Msgbox ("No Points To Triangulate", "No Points", cMsgboxOK, cMsgboxExclamation)
	End If
End Sub

Sub PlotPoints
	Dim px,py
	
	WaitCursor(True)
	Stock.Stock.Line(0,0,238,390,cWhite,BF)
	Stock.Stock.FErase(0,0,238,390)
	For i=0 To ArrayLen(CoOrds())-1'Number
		px=CoOrds(i).X
		py=CoOrds(i).Y
		Stock.Stock.FLine(px,py,px+1,py+1,cRed,BF) 
	Next i
	WaitCursor(True)
	PlotShade
	DrawTriangles
	ContourCalc
End Sub

Sub Menu14_Click
	OK.Visible=False
	Stock.Stock.Close 
End Sub

Sub DrawTriangles
	If Tin=1 Then
		For i = 0 To ArrayLen(Triangles()) - 1
			Stock.Stock.Line(CoOrds(Triangles(i).V1).X, CoOrds(Triangles(i).V1).Y, _
						CoOrds(Triangles(i).V2).X, CoOrds(Triangles(i).V2,1),cBlue)
			Stock.Stock.Line(CoOrds(Triangles(i).V2).X, CoOrds(Triangles(i).V2).Y, _
						CoOrds(Triangles(i).V3,0), CoOrds(Triangles(i).V3,1),cBlue)
			Stock.Stock.Line(CoOrds(Triangles(i).V3).X, CoOrds(Triangles(i).V3).Y, _
						CoOrds(Triangles(i).V1).X, CoOrds(Triangles(i).V1).Y,cBlue)
		Next
	End If
End Sub

Public Sub LineFound(xp,yp,x1,y1,x2,y2,dx1)
	Dim a,b,c,d,m
	' xp  yp  coordinates of the point
	' x1,y1  x2,y2 coordinates of the line
	' dx number of pixels for magnet
	
	If xp<Min(x1,x2) OR xp>Max(x1,x2) OR yp<Min(y1,y2) OR yp>Max(y1,y2) Then
		Return False
	Else If x1=x2 AND xp-dx>x1 AND xp+dx<x1 AND y2>y1 AND yp-dx<y2 AND yp+dx>y1 Then
		Return True
	Else If x1=x2 AND xp-dx>x1 AND xp+dx<x1 AND y2<y1 AND yp-dx<y1 AND yp+dx>y2 Then
		Return True
	Else If y1=y2 AND yp-dx>y1 AND yp+dx<y1 AND x2<x1 AND xp-dx<x1 AND xp+dx>x2 Then
		Return True
	Else If y1=y2 AND yp-dx>y1 AND yp+dx<y1 AND x1<x2 AND xp-dx<x2 AND xp+dx>x1 Then
		Return True
	End If
	
	a=y2-y1
	b=x2-x1
	c=-a*x1+b*y1
	d=Abs((a*xp-b*yp+c)/Sqrt(a*a+b*b))	' distance between point and line
	If Abs(d)<=dx1 Then
		Return True
	Else
		Return False
	End If
End Sub

Sub IsTriangle(x,y)
	Dim i
	Dim x1,y1,x2,y2
	
	t1=0
	t2=0
	
	For i = 0 To ArrayLen(Triangles()) - 1
		x1=CoOrds(Triangles(i).V1).X
		y1=CoOrds(Triangles(i).V1).Y
		x2=CoOrds(Triangles(i).V2).X
		y2=CoOrds(Triangles(i).V2).Y
		If LineFound(x,y,x1,y1,x2,y2,3)=True Then
			If t1=0 Then
				t1=i :t3=2
				p11=Triangles(i,0)
				p12=Triangles(i,1)
				p13=Triangles(i,2)
			Else
				t2=i :t4=2
				p21=Triangles(i,0)
				p22=Triangles(i,1)
				p23=Triangles(i,2)
				Return 2
			End If
		Else
			x1=CoOrds(Triangles(i).V2).X
	 		y1=CoOrds(Triangles(i).V2).Y
 			x2=CoOrds(Triangles(i).V3).X
			y2=CoOrds(Triangles(i).V3).Y
			If LineFound(x,y,x1,y1,x2,y2,3)=True Then
				If t1=0 Then
					t1=i :t3=0
					p11=Triangles(i,1)
					p12=Triangles(i,2)
					p13=Triangles(i,0)
				Else
					t2=i :t4=0
					p21=Triangles(i,1)
					p22=Triangles(i,2)
					p23=Triangles(i,0)
					Return 2
				End If
			Else
				x1=CoOrds(Triangles(i).V1).X
				y1=CoOrds(Triangles(i).V1).Y
				x2=CoOrds(Triangles(i).V3).X
				y2=CoOrds(Triangles(i).V3).Y
				If LineFound(x,y,x1,y1,x2,y2,3)=True Then
					If t1=0 Then
						t1=i :t3=1
						p11=Triangles(i,0)
						p12=Triangles(i,2)
						p13=Triangles(i,1)
					Else
						t2=i :t4=1
						p21=Triangles(i,0)
						p22=Triangles(i,2)
						p23=Triangles(i,1)
						Return 2
					End If
				End If
			End If
		End If
	Next
	If t1>0 AND t2=0 Then
		Return 1
	Else
		Return 0
	End If

End Sub

Sub SwapTri
	Stock.Stock.Line (CoOrds(p11).x, CoOrds(p11).y,CoOrds(p12).x, CoOrds(p12).y,cWhite)
	Stock.Stock.Line (CoOrds(p13).x, CoOrds(p13).y,CoOrds(p23).x,CoOrds(p23).y,cBlue)
	Triangles(t1,0)=p13
	Triangles(t1,1)=p23
	Triangles(t1,2)=p11
	Triangles(t2,0)=p13
	Triangles(t2,1)=p23
	Triangles(t2,2)=p12
End Sub

Sub TriArea(x,y)
	Dim i
	Dim x1,y1,x2,y2,x3,y3
	Dim Area1,Area2,Area3,Area4
	
	t1=0
	For i = 0 To ArrayLen(Triangles()) - 1
		x1=CoOrds(Triangles(i).V1).X
		y1=CoOrds(Triangles(i).V1).Y
		x2=CoOrds(Triangles(i).V2).X
		y2=CoOrds(Triangles(i).V2).Y
		x3=CoOrds(Triangles(i).V3).X
		y3=CoOrds(Triangles(i).V3).Y
		Area1=(((x1*y2)-(y1*x2))+((x2*y3)-(y2*x3))+((x3*y1)-(y3*x1)))*0.5
		Area2=(((x1*y2)-(y1*x2))+((x2*y)-(y2*x))+((x*y1)-(y*x1)))*0.5
		Area3=(((x1*y)-(y1*x))+((x*y3)-(y*x3))+((x3*y1)-(y3*x1)))*0.5
		Area4=(((x*y2)-(y*x2))+((x2*y3)-(y2*x3))+((x3*y)-(y3*x)))*0.5
		If Area1=Abs(Area2)+Abs(Area3)+Abs(Area4) Then
			t1=i
		End If
	Next i
End Sub

Sub Stock_MouseDown (x,y)
	If Swap=1 Then
		Ret=IsTriangle(x,y)
		If Ret=2 Then
			SwapTri
		End If
	Else If DelTin=1 Then
		TriArea(x,y)
		If t1>0 Then
			For i=t1+1 To ArrayLen(Triangles())-1
				'CoOrds(Triangles(i-1).V1).X=CoOrds(Triangles(i).V1).X :CoOrds(Triangles(i-1).V1).Y=CoOrds(Triangles(i).V1).Y
				'CoOrds(Triangles(i-1).V2).X=CoOrds(Triangles(i).V2).X :CoOrds(Triangles(i-1).V2).Y=CoOrds(Triangles(i).V2).Y
				'CoOrds(Triangles(i-1).V1).X=CoOrds(Triangles(i).V3).X :CoOrds(Triangles(i-1).V3).Y=CoOrds(Triangles(i).V3).Y
			Next i
			'ArrayLen(Triangles())=ArrayLen(triangles())-2
			'Msgbox(ArrayLen(triangles()) & "  " & t1)
			DrawTriangles
		End If
	Else If Bound=1 AND Tin=1 Then
		FindClosePoint(x,y)
		If True Then
			If t4=0 Then
				Stock.Stock.FCircle(CoOrds(t3).X, CoOrds(t3).Y, 4, cGreen)
			Else
				Stock.Stock.FCircle(CoOrds(t3).X, CoOrds(t3).Y, 4, cRed)
			End If
			BBoundary(t4).X=Points(t3).X :BBoundary(t4).Y=Points(t3).Y :BBoundary(t4).Z=Points(t3).Z
			If t4=0 Then
				t1=CoOrds(t3).X
				t2=CoOrds(t3).Y
			End If
			Stock.Stock.Line(t1,t2,CoOrds(t3).X,CoOrds(t3).Y,cBlack)
			t1=CoOrds(t3).X
			t2=CoOrds(t3).Y
			t4=t4+1
		End If
	End If
End Sub

Public Sub FindClosePoint(x,y)
	xmax = x + 15
	xmin = x - 15
	ymax = y + 15
	ymin = y - 15
	For i = 0 To ArrayLen(CoOrds()) -1
		If CoOrds(i).X > xmin AND CoOrds(i).X < xmax Then
			If CoOrds(i).Y > ymin AND CoOrds(i).Y < ymax Then
				t3=i
				Return True
			End If		
		End If
	Next

End Sub

Sub Stock_MouseMove(x,y)
	'South African Survey Coordinate System
	Label4.Text="Y: " & Format(MaxX-((x-15)/XScale),"F3") & " X: " & Format(MinY+((y-15)/YScale),"F3")
End Sub

#End Region

#Region ************************************** Contours

Sub Menu8_Click
	If Tin=1 Then
		If Contour=1 Then Contour=0 Else Contour=1
		If Contour=1 Then
			Contour.Show
		Else
			PlotPoints
		End If
	Else
		Msgbox ("No Tin Model Has Been Created", "No Tin Model", cMsgboxOK, cMsgboxExclamation)
	End If
	OK.Visible=False
End Sub

Sub Contour_Show
	WaitCursor(True)
	DrawBorder(1,cBlack)
	Textbox1.Text=Format(MinZ,"F3") :Textbox2.Text=Format(MaxZ,"F3")
	Textbox3.Focus
	WaitCursor(False)
End Sub

Sub Textbox1_LostFocus
	If IsNumber(Textbox1.Text)=False Then Textbox1.Text=0
	Textbox1.Text=Format(Textbox1.Text,"F3")
End Sub

Sub Textbox2_LostFocus
	If IsNumber(Textbox2.Text)=False Then Textbox2.Text=0
	Textbox2.Text=Format(Textbox2.Text,"F3")
End Sub

Sub Textbox3_LostFocus
	If IsNumber(Textbox3.Text)=False Then Textbox3.Text=1
	Textbox3.Text=Format(Textbox3.Text,"F3")
	Textbox1.Text=Format((Int(Textbox1.Text/Textbox3.Text))*Textbox3.Text,"F3")
End Sub

Sub OKCon_Click
	'calc contours
	ContourCalc
End Sub

Sub ContourCalc
	Dim ConLevel,i1,OK1,L1,L2,L3,dy1,dx1
	
	If Textbox1.Text<>"" AND Textbox2.Text<>"" AND Contour=1 Then
		Stock.Stock.FErase(0,0,238,390)
		Swap=0 
		Contour.Close
		DoEvents
		WaitCursor(True)
		If IsNumber(Textbox3.Text)=False Then Textbox3.Text=Format(1,"F0")
		For ConLevel=Textbox1.Text To Textbox2.Text Step Textbox3.Text
			For i = 0 To ArrayLen(Triangles()) - 1	
				OK1=0
				If (ConLevel>=PPoints(Triangles(i).V1).Z AND ConLevel<PPoints(Triangles(i).V2).Z) OR (ConLevel>PPoints(Triangles(i).V2).Z AND ConLevel<=PPoints(Triangles(i).V1).Z) Then 
					CalcContour(ConLevel,CoOrds(Triangles(i).V1).X,CoOrds(Triangles(i).V2).X,CoOrds(Triangles(i).V1).Y,CoOrds(Triangles(i).V2).Y,PPoints(Triangles(i).V1).Z,PPoints(Triangles(i).V2).Z)
					dx1=dx :dy1=dy :OK1=Ok1+1
				End If
				If (ConLevel>=PPoints(Triangles(i).V2).Z AND ConLevel<PPoints(Triangles(i).V3).Z) OR (ConLevel>PPoints(Triangles(i).V3).Z AND ConLevel<=PPoints(Triangles(i).V2).Z) Then 
					CalcContour(ConLevel,CoOrds(Triangles(i).V2).X,CoOrds(Triangles(i).V3).X,CoOrds(Triangles(i).V2).Y,CoOrds(Triangles(i).V3).Y,PPoints(Triangles(i).V2).Z,PPoints(Triangles(i).V3).Z)
					If OK1=0 Then
						dx1=dx :dy1=dy 
					End If
					OK1=OK1+1
				End If
				If (ConLevel>=PPoints(Triangles(i).V3).Z AND ConLevel<PPoints(Triangles(i).V1).Z) OR (ConLevel>PPoints(Triangles(i).V1).Z AND ConLevel<=PPoints(Triangles(i).V3).Z) Then 
					CalcContour(ConLevel,CoOrds(Triangles(i).V3).X,CoOrds(Triangles(i).V1).X,CoOrds(Triangles(i).V3).Y,CoOrds(Triangles(i).V1).Y,PPoints(Triangles(i).V3).Z,PPoints(Triangles(i).V1).Z)
					If OK1=0 Then
						dx1=dx :dy1=dy 
					End If
					OK1=OK1+1
				End If
				If OK1>1 Then
					Stock.Stock.FLine(dx,dy,dx1,dy1,Rgb(192,0,0))
				End If
			Next i
		Next ConLevel
		WaitCursor(False)
	End If
End Sub

Sub CalcContour(ConLev,LX,LX1,LY,LY1,LZ,LZ1)
	Dim m1,m2
	If LZ<>LZ1 Then
		m1=(LX-LX1)/(LZ-LZ1)
		m2=(LY-LY1)/(LZ-LZ1)
	Else
		m1=0 :m2=0
	End If
	dx=LX+((Conlev-LZ)*m1)
	dy=LY+((Conlev-LZ)*m2)
	
End Sub

Sub ExitCon_Click
	Contour.Close
End Sub

#End Region

#Region ********************************* Boundary

Sub Menu10_Click
	If Bound=0 Then Bound=1 Else Bound=0
	If Tin=1 Then
		Swap=0 :DelTin=0 :Bound=1 :t4=0
		OK.Visible=True
	Else
		Msgbox ("No Tin Model Has Been Created\Displayed", "No Tin Model", cMsgboxOK, cMsgboxExclamation)
	End If
End Sub

Sub OK_Click
	WaitCursor(True)
	Dim Boundary(t4,3) As Single
	For i=0 To t4-1
		Boundary(i).X=BBoundary(i).X :Boundary(i).Y=BBoundary(i).Y :Boundary(i).Z=BBoundary(i).Z
	Next i
	If T4>2 Then
		BTriangles() = D2D.TriangulatePoints(Boundary())
	End If
	OK.Visible=False
	PlotPoints
	WaitCursor(False)
End Sub

#End Region

#Region ******************************* Area

Sub Menu13_Click
	Dim Vol,i1,i2
	
	If Bound=1 Then
		WaitCursor(True)
		Vol=0
		i2=ArrayLen(Boundary())-1
		If i2>1 Then
			For i1=0 To ArrayLen(Boundary())-2
				Vol=Vol+((Boundary(i1).X*Boundary(i1+1).Y)-(Boundary(i1).Y*Boundary(i1+1).X))
			Next i1
			Vol=Vol+((Boundary(i2).X*Boundary(0).Y)-(Boundary(i2).Y*Boundary(0).X))
			Vol=Abs(Vol)/2
		End If
		WaitCursor(False)
		Msgbox("Area = " & Format(Vol,"F3"), "Area", cMsgboxOK, cMsgboxNone)
	Else
		Msgbox("No Boundary Has Been Defined", "No Boundary", cMsgboxOK, cMsgboxExclamation)
	End If
End Sub

#End Region

#Region ********************************* Volumes

Sub Menu12_Click
	Dim Vol,i1,i2,i3
	Dim a,a1,a2,a3,a4
	Dim l,l1,l2
	
	If Bound=1 Then
		WaitCursor(True)
		Vol=0
		For i=0 To ArrayLen(Triangles())-1
			tx(0)=PPoints(Triangles(i).V1).X 
			ty(0)=PPoints(Triangles(i).V1).Y 
			tz(0)=PPoints(Triangles(i).V1).Z
			tx(1)=PPoints(Triangles(i).V2).X 
			ty(1)=PPoints(Triangles(i).V2).Y 
			tz(1)=PPoints(Triangles(i).V2).Z
			tx(2)=PPoints(Triangles(i).V3).X 
			ty(2)=PPoints(Triangles(i).V3).Y 
			tz(2)=PPoints(Triangles(i).V3).Z
			i2=0
			For i1=0 To ArrayLen(BTriangles())-1
				bx(0)=Boundary(BTriangles(i1).V1).X
				by(0)=Boundary(BTriangles(i1).V1).Y
				bz(0)=Boundary(BTriangles(i1).V1).Z
				bx(1)=Boundary(BTriangles(i1).V2).X
				by(1)=Boundary(BTriangles(i1).V2).Y
				bz(1)=Boundary(BTriangles(i1).V2).Z
				bx(2)=Boundary(BTriangles(i1).V3).X
				by(2)=Boundary(BTriangles(i1).V3).Y
				bz(2)=Boundary(BTriangles(i1).V3).Z
				a=0 :a1=0 :a2=0 :a3=0
				For i2=0 To 2
					For i3=0 To 1
						a= WhichTriangle(tx(i2),ty(i2),bx(i3),by(i3),bx(i3+1),by(i3+1))
						If a=0 Then a1=a1+1
						If a=-1 Then a2=a2+1
						If a=1 Then a3=a3+1
					Next i3
					a= WhichTriangle(tx(i2),ty(i2),bx(2),by(2),bx(0),by(0))
					If a=0 Then a1=a1+1
					If a=-1 Then a2=a2+1
					If a=1 Then a3=a3+1
				Next i2
				If (a1<=3 AND a2<=3) OR (a1<=3 AND a3<=3) Then
					'calc the volume
					l=CalcBotLevel(tx(0),ty(0),bx(0),by(0),bz(0),bx(1),by(1),bz(1),bx(2),by(2),bz(2))
					l1=CalcBotLevel(tx(1),ty(1),bx(0),by(0),bz(0),bx(1),by(1),bz(1),bx(2),by(2),bz(2))
					l2=CalcBotLevel(tx(2),ty(2),bx(0),by(0),bz(0),bx(1),by(1),bz(1),bx(2),by(2),bz(2))
					a4=CalcArea(tx(0),ty(0),tx(1),ty(1),tx(2),ty(2))
					Vol=Vol+Abs((((tz(0)-l)+(tz(1)-l1)+(tz(2)-l2))/3)*a4)/3
				End If
			Next i1
		Next i
		WaitCursor(False)
		Msgbox("Volume = " & Format(Vol,"F3"), "Volume", cMsgboxOK, cMsgboxNone)
	Else
		Msgbox("No Boundary Has Been Defined", "No Boundary", cMsgboxOK, cMsgboxExclamation)
	End If
End Sub

Sub CalcBotLevel(A,A1,B,B1,B2,C,C1,C2,D,D1,D2)
	'first we calc the heights of the botton triangle where the top triangle intersects
	'we use the weight method
	Dim area,area1,area2,area3
	Dim e1
	
	area1=CalcArea(A,A1,B,B1,C,C1)
	area2=CalcArea(A,A1,C,C1,D,D1) 
	area3=CalcArea(A,A1,D,D1,B,B1) 
	area=area1+area2+area3
	e1=((area1/area)*D2) + ((area2/area)*B2) + ((area3/area)*C2) 
	Return e1
	
End Sub

Sub CalcArea(x1,y1,x2,y2,x3,y3)
	Dim Area1
	
	Area1=(((x1*y2)-(y1*x2))+((x2*y3)-(y2*x3))+((x3*y1)-(y3*x1)))*0.5
	Return Area1
End Sub

Sub WhichTriangle(xp, yp, x1, y1, x2, y2)
'Determines which side of a line the point (xp,yp) lies.
'The line goes from (x1,y1) to (x2,y2)
'Returns -1 for a point to the left
'         0 for a point on the line
'        +1 for a point to the right
 
	Dim equation

	equation = ((yp - y1) * (x2 - x1)) - ((y2 - y1) * (xp - x1))

	If equation > 0 Then
		Return -1
	Else If equation = 0 Then
		Return 0
	Else
		Return 1
	End If

End Sub

#End Region

#Region **************************************** List The Data

Sub Menu17_Click
	WaitCursor(True)
	Stock.Stock.Color=Rgb(220,220,220)
	Table1.Clear
	For i=1 To Number
		Table1.AddRow(Points(i).X,Points(i).Y,Points(i).Z)
	Next i
	Panel1.Left=0 :Panel1.Top=5
	WaitCursor(False)
End Sub

Sub ExitList_Click
	Stock.Stock.Color=Rgb(255,255,255)
	PlotPoints
	Panel1.Left=300
End Sub

#End Region

#Region ***************************** Color Shading

Sub PlotShade
	Dim colorcon,ColorZ,ConZ

	WaitCursor(True)
	If Shade=1 Then
		ColorCon=Int(255/(MaxZ-MinZ))
		For i=0 To ArrayLen(Triangles())-1
			s1(0).x=CoOrds(Triangles(i).V1).X 
			s1(0).y=CoOrds(Triangles(i).V1).Y 
			s1(1).x=CoOrds(Triangles(i).V2).X 
			s1(1).y=CoOrds(Triangles(i).V2).Y 
			s1(2).x=CoOrds(Triangles(i).V3).X 
			s1(2).y=CoOrds(Triangles(i).V3).Y 
			ConZ=(PPoints(Triangles(i).V1).Z+PPoints(Triangles(i).V2).Z+PPoints(Triangles(i).V3).Z)/3 
			ColorZ=Int((ConZ-MinZ)*ColorCon)
			If ColorZ>255 Then ColorZ=255
			If ColorZ<0 Then ColorZ=0
			Stock.Stock.Polygon(s1(),0,3,Rgb(ColorZ,ColorZ,255-ColorZ),F)
		Next i
	End If
	WaitCursor(False)
End Sub

Sub Menu19_Click
	If Shade=1 Then Shade=0 Else Shade=1
	PlotPoints
End Sub

#End Region
